/*
 * This software module ViSBD (View Synthesis Based on Disparity /Depth was originally developed by 
 * THOMSON INC. in the course of development of the ISO/IEC JTC1/SC29 WG 11 (MPEG) 3D Video for reference 
 * purposes and its performance may not have been optimized.
 *
 * Those intending to use this software module in products are advised that its use may infringe 
 * existing patents. ISO/IEC have no liability for use of this software module or modifications thereof.
 *
 * Assurance that the originally developed software module can be used
 *   (1) in the ISO/IEC JTC1/SC29 WG 11 (MPEG) 3D Video once the it is adopted to be used as reference 
 *       software; and
 *   (2) to develop the codec for ISO/IEC JTC1/SC29 WG 11 (MPEG) 3D Video.
 *
 * To the extent that THOMSON INC. OR ANY OF ITS AFFILIATES owns patent rights that would be required to 
 * make, use, or sell the originally developed software module or portions thereof included in the ISO/IEC 
 * JTC1/SC29 WG 11 (MPEG) 3D Video in a conforming product, THOMSON INC. will assure the ISO/IEC that it 
 * is willing to negotiate licenses under reasonable and non-discriminatory terms and conditions with 
 * applicants throughout the world.
 *
 * THOMSON INC. retains full right to modify and use the code for its own purpose, assign or donate the 
 * code to a third party and to inhibit third parties from using the code for products that do not conform 
 * to MPEG-related and/or ISO/IEC International Standards. 
 *
 * This copyright notice must be included in all copies or derivative works.
 * Copyright (c) ISO/IEC 2008.
 *
 * Authors:
 *      Dong Tian,  dong.tian@thomson.net
 *      Zefeng Ni,  zefeng.ni@thomson.net 
 *
 */

#ifndef PICTURERESAMPLE_H
#define PICTURERESAMPLE_H

#include "ViewSynDef.h"
#include "ViewSynAPI.h"



//typedef struct upsample_table
//{
//	int value_mul5;
//	int value_mul20;
//}UpsampleTable;

class CPictureResample
{
private:

  // Algorithm 0: Simple repeat /drop pixels
  void RepeatPixel420to444(imgpel** oPic, imgpel** iPic, int Width, int Height);
  void DropPixel444to420  (imgpel** oPic, imgpel** iPic, int Width, int Height);

  unsigned char PixelClip(const int pxlVal);
  
  void DoUpsample(imgpel** Yo, imgpel** Yi, int Width, int Height);
  void DoDownsample(imgpel** Yo, imgpel** Yi, int Width, int Height);

public:
  CPictureResample();
  ~CPictureResample();
  
  //void Set(int iWidth, int iHeight, int iAlg = 0);
  int  State();
  
  // For UV format conversion
  void PictureResample420to444(imgpel** oPic, imgpel** iPic, int Width, int Height);
  void PictureResample444to420(imgpel** oPic, imgpel** iPic, int Width, int Height);

  void PictureResample420to444ForRefView(imgpel** output_left_u, imgpel** input_left_u, 
										 imgpel** output_left_v, imgpel** input_left_v,
										 imgpel** output_right_u,imgpel** input_right_u,
										 imgpel** output_right_v,imgpel** input_right_v,
										 int Width, int Height,int SynDir);
  void PictureResample444to420ForRefView(imgpel** output_left_u, imgpel** input_left_u, 
										 imgpel** output_left_v, imgpel** input_left_v,
										 imgpel** output_right_u,imgpel** input_right_u,
										 imgpel** output_right_v,imgpel** input_right_v,
										 int Width, int Height);
  
  // For picture upsample and downsample
  int UpsampleView(imgpel** Yo, imgpel** Yi, int Width, int Height, int Factor);
  int DownsampleView(imgpel** Yo, imgpel** Yi, int Width, int Height, int Factor);

  int UpsampleRefView(imgpel**left_output_Y,imgpel**left_input_Y,
					  imgpel**left_output_U,imgpel**left_input_U,
					  imgpel**left_output_V,imgpel**left_input_V,
					  imgpel**left_output_depth,imgpel**left_input_depth,
					  imgpel**right_output_Y,imgpel**right_input_Y,
					  imgpel**right_output_U,imgpel**right_input_U,
					  imgpel**right_output_V,imgpel**right_input_V,
					  imgpel**right_output_depth,imgpel**right_input_depth,
					  int Width, int Height, int Factor,int SynDirection);
#if QC_VSP_Asymmetric_Resolution
  int UpsampleRefView420(imgpel**left_output_Y,imgpel**left_input_Y,
					  imgpel**left_output_U,imgpel**left_input_U,
					  imgpel**left_output_V,imgpel**left_input_V,
					  imgpel**left_output_depth,imgpel**left_input_depth,
					  imgpel**right_output_Y,imgpel**right_input_Y,
					  imgpel**right_output_U,imgpel**right_input_U,
					  imgpel**right_output_V,imgpel**right_input_V,
					  imgpel**right_output_depth,imgpel**right_input_depth,
					  int Width, int Height, int Factor,int SynDirection);

  int DownsampleRefView420(imgpel**output_Y,imgpel**input_Y,
						imgpel**output_U,imgpel**input_U,
						imgpel**output_V,imgpel**input_V,
						imgpel**output_depth,imgpel**input_depth,
						int Width, int Height, int Factor);
#endif

  int DownsampleRefView(imgpel**output_Y,imgpel**input_Y,
						imgpel**output_U,imgpel**input_U,
						imgpel**output_V,imgpel**input_V,
						imgpel**output_depth,imgpel**input_depth,
						int Width, int Height, int Factor);

private:
	 // UpsampleTable	  AVCFir6TapUpsampleTable[PIXEL_VALUE_RANGE];
	int PixelValueMul20[PIXEL_VALUE_RANGE];
	int PiXelValueMul5[PIXEL_VALUE_RANGE];
};

#endif
