#ifndef _VIEWSYNDEF_H_
#define _VIEWSYNDEF_H_

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "vs_memalloc.h"

#define  VSP_OPTIMIZATION      1
#define  PIXEL_VALUE_RANGE     256

#define REDUCED_RES                   1
#if REDUCED_RES
#define QC_VSP_Asymmetric_Resolution  1
#endif

#define QCOM_VSP              1  //!< 1: Enable 1LWH. 0: Disable. -Li
#if QCOM_VSP
#define ZJU_VSP               1  //!< 1: Enable 1LWH with splatting. 0: Disable (original code from QualCOMM). -Yin.
#define BOUNDARY_DETECT_ATM02 1
#endif

#define POZNAN_NONLINEAR_DEPTH        1

#define NTT_SUBPEL_VSP_M24796         1

#if (QC_VSP_Asymmetric_Resolution & NTT_SUBPEL_VSP_M24796)
#define NTT_VSP_HARMONIZATION_M25195  0
#endif

#define NOKIA_CHROMA_BILINEAR         1


#ifndef CLIP
#define CLIP(x,min,max) ( (x)<(min)?(min):((x)>(max)?(max):(x)) )
#endif


#define LEFTVIEW  0
#define RGHTVIEW  1



//hole filling related
#define HOLEPIXEL    1
#define NOTHOLEPIXEL 0

//depth edge detection related, Zhejiang Univ.
#define NONE    0
#define RISE    1 //the top point of a rising edge
#define FALL    2 //the top point of a falling edge
#define AROUND  3 //the area around edge to be used in Boundary-Aware Splatting
#define SUSPECT 4 //pixel do not be warped for the sake of cleaning boundary noise

// temporal improvement related
#define TEMPOBLOCK3 0  //1(ON) temporal block =3, 0(OFF): =5;

// The index number
#define LEFTVIEW  0
#define RGHTVIEW  1
#define MERGVIEW  2
#define HLFLVIEW  3
#define FINLVIEW  4

//Zhejiang, DEBUG test info
#define DEBUG_ZHEJIANG 0

#endif