#ifndef __ALC_LOGIC__
#define __ALC_LOGIC__


//#include "..\..\lencod\inc\defines.h"
//#include "..\..\lencod\inc\global.h"

#include "defines.h"
#include "global.h"


#define ALC_OPT1                                                                     (2)

//this define allows to use probably more effective structures that emulate "lists" for storing histogram data
//0 - classicial arrays are used to address appropriate array element directly through pixel value
//1 - using of "list" that simlpy stores all the cells of histgram one by another
// in this case a lot of operations become simpler(they look so): initialization and clearining, runing over, etc
// to be verified in the real experiments
#define LST_IMPL_OF_ACC																                               (1)

// This define allows using of special mark variable that increments each call of GetTM in order to check whether bin has been updated or not. No memset per GetTM
#define USE_TRY_MARK_ALC                                                             (1)

/*
  EARLY_ALC_OFF_DETECTION -in case of LST_IMPL_OF_ACC ==0, this define allows to compare sums of templates and exclude ALC_Correction if templates differencies are not crucial

  EARLY_ALC_OFF_DETECTION_THRESHOLD defines how strong ref_sum/dec_sum will be quantizaed before comparison; it uses as follows:
  ref_sum >> = EARLY_ALC_OFF_DETECTION_THRESHOLD;
  dec_sum >> = EARLY_ALC_OFF_DETECTION_THRESHOLD;
*/
  
#define EARLY_ALC_OFF_DETECTION                                                      (1)
#define EARLY_ALC_OFF_DETECTION_THRESHOLD                                            (4)


// NO_DIVISION_CORRECTION_ALC== 1 - correction is implemented w/o division; only via table ops and shifts
#define NO_DIVISION_CORRECTION_ALC                                                   (0)

// ALC_OPT_REF_REF0_BEHAVIOR=0 --> no verification on zero-denumerator case
#define ALC_OPT_REF_REF0_BEHAVIOR				                                             (0)

#define FIXED_POINT					1
#if(FIXED_POINT)
#define FIXED_POINT_PRESISION_SHIFT		                                                15
#define FIXED_POINT_PRESISION_MUL (1<<FIXED_POINT_PRESISION_SHIFT)
#define FIXED_POINT_INTER_SHIFT				                                                8


/*
32 = PRECISION_FOR_INT_DIVISION + PRELIM_QUANT_FOR_INT_DIVISION + 8
*/
#define PRECISION_FOR_INT_DIVISION		                                                (15)
#define PRELIM_QUANT_FOR_INT_DIVISION                                                 (8)
#endif

#define SMRC_SILENT_ALC_4_PSKIP_CONSTRAINTS_4IV_ONLY		                              1
#define SMRC_SILENT_ALC_4_PSKIP_WITHOUT_SIMILAR_TEMPLATES	                            1
#define SIMILAR_THRESHOLD																    4
#define SMRC_SILENT_ALC_4_PSKIP_WITHOUT_DISSIMILAR_TEMPLATES		                      1
#define DISSIMILAR_MR_THRESHOLD																3
#define DISSIMILAR_DC_THRESHOLD																48

#define ALC_SPEED_OPT				                                                          1
//#define ALC_RIGHT_RIGHT_BORDER_IF				                                            0

#define ALC_SIGNCHNECK_OUTLIER_REJECTION                                              0 // those pairs of ref/dec are excluded from further consideration whose sign of difference is differed from majority of signes within bin
#if ALC_SIGNCHNECK_OUTLIER_REJECTION
#define ALC_SIGNCHNECK_OUTLIER_REJECTION_TH                                           (10)
#define ALC_SIGNCHNECK_OUTLIER_REJECTION_ELEM_REF_DEC_TH                              (6)
#endif

#define WEIGHT_MODEL								                                                  (0)	// 0 - 1-parameter model of weights in ALC
																			                                                          // otherwise - 3-parameter model of weights in ALC.

#define EXP_TABLE_HALF                                                                (0) //if 1- then exp tables are defined for only positive differencies ( 0...255); 
                                                                                         //if 0 - then positive and negative as well

#define FIXED_UNIT_WEIGHT                                                             (1) // 1 - all weights are equal to 1. No pixel-alc.

#if( 1 == FIXED_UNIT_WEIGHT)

/*
USE_SINGLE_MULTIPLIER = 1  - simplest correction that exclude any serios calculations from the main correction cycle. Only shift is used per each pixel.
The following equations are used:

1) DEC_REF_RATIO = is calculated as: (1 << SINGL_MULT_FACT_PREC) * Dec / Ref;
2) correction is done as follows:
  
  Corrected_vl = (reference_vl * DEC_REF_RATIO) >> SINGL_MULT_FACT_PREC;
*/


/*
USE_SINGLE_MULTIPLIER = 2  - more complex but still quite simple correction that exclude accomulations that are done per each pixel. int division is included
The following equations are used:

  Corrected_vl = (reference_vl * dec + (ref>>1)) / ref;
*/


/*
USE_SINGLE_MULTIPLIER = 0  - even more complex but still quite simple correction that inlclude accomulations performed per each pixel w/o weights but with ref_ref thresholod analysis. int division is included
The following equations are used:

  Corrected_vl = (reference_vl * dec + (ref>>1)) / ref;
*/

#define USE_SINGLE_MULTIPLIER                                                         (1)


//precision to be used for USE_SINGLE_MULTIPLIER = 1 based on 32bit signed arithmetic
#define SINGL_MULT_FACT_PREC                                                          (15)
#define MULT_FACTOR_X_255                                                             (255 << SINGL_MULT_FACT_PREC)
#else
#define USE_SINGLE_MULTIPLIER                                                         (0)
#endif




#ifndef CLIP
#define CLIP(x,min,max) ( (x)<(min)?(min):((x)>(max)?(max):(x)) )
#endif

typedef imgpel XPel;

typedef struct strTemplateComponent
{
	//int y;
	//int x;
	XPel vl;	
} XYVL_STRUCT;


/*
	Number and values of different sigma for PiLC smoothing
*/
#define NUMBER_OF_SIGMA											(3)

// in case of block-alc wighted usage of left/top means is happen instead of directional one. Weights are taken from PALC
#define WEIGHTED_BLK_DIR_ALC

// in case if WEIGHTED_BLK_DIR_ALC is defined, this define turns on PALC-like method of estimation of new Mx.
#define PALC_BLK_ALC


//maximum thickness of template. Is expressed in pixels
#define MAX_TEMPLATE_SIZE                                       (4)

#define USE_APPROXIMATED_REF_ACC                                (0) // if it is NOT defined, accomulation of reference values is used (without any relations with SAVE_REF_MEAN_4_EACH_BIN)

#define AVERAGED_FACTOR_SH                                      (0)

#if (AVERAGED_FACTOR_SH)
#define AVERAGED_FACTOR_ROUNDING    (1 << (AVERAGED_FACTOR_SH - 1))
#define SAVE_REF_MEAN_4_EACH_BIN                                 0
#else
#define AVERAGED_FACTOR_ROUNDING                                (0)
#define SAVE_REF_MEAN_4_EACH_BIN                                (0)
#endif

// max MB Size 16
#define MAX_TEMPLATE_VOLUME										((MAX_TEMPLATE_SIZE * 16) * 2 + (MAX_TEMPLATE_SIZE * MAX_TEMPLATE_SIZE))

//Threshold of difference between template values in reference and decoded frames
#define REF_DEC_LUMA_DIF_THRESHOLD								(30)          // if REF_DEC_LUMA_DIF_THRESHOLD == 256, then no comparison between ref and dec to be applied at all
#define REF_REF_LUMA_DIF_THRESHOLD								(60)
//#define REF_REF_LUMA_DIF_THRESHOLD								(1000)

//#define ALC_TEMPLATE_SIZE_LUMA									(4)
//#define ALC_TEMPLATE_SIZE_CHROMA								(4)

#define HYST_THRESHOLD 0;

typedef struct strTemplateHistBin
{
	int acc;
	int acc_volume;
#if(SAVE_REF_MEAN_4_EACH_BIN || 0 == USE_APPROXIMATED_REF_ACC)
	int acc_ref;
#endif

#if ALC_SIGNCHNECK_OUTLIER_REJECTION
   int acc_minus;
    int acc_plus;
    int acc_zero;
    int acc_plus_sub_minus;
    int acc_plus_add_minus;
    int abs_acc_plus_sub_minus;
#endif
} TMPL_HIST_BIN;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//													Types of ALC methods
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define PIX_ALC													(0)  // pixel correction by means of multi coefficient determined over template
#define VSPLIKE													(1)  // simple VSP
#define BLK_ALC													(2)	 // multi ALC, that is based on determination of a multi coefficient that connects two means values: ref and dec, that are selected from the template
#define PIX_ALC_ONLY_MX_CORRECTION      (3)  // similar to PIX_ALC but this method changes only MX
#define ADDITIVE_MX_CORRECTION          (4)	 // Additive correction of luma. Analysis of two halfs of template. Selection of global difference between templates if difference of two corrections is smaller then LUMA_CORRECTION_TEMPLATE_DIFF.
																	 // Else: Selection of correction which corresponds to reference part and which mean value is closer to reference mean
#define PIX_LINREG_ALC											(5)  // Use linear regression model for compensation of reference
#define BLK_DIRALC												(6)	 // multi ALC, that is based on determination of a multi coefficient that connects two means values: ref and dec, that are selected from the template. Additional conditions are checked
#define BLK_WALC_MIX											(7)	 // multi ALC, that is based on determination of a multi coefficient that connects two means values: ref and dec, that are selected from the template. Additional conditions are checked
#define BLK_WALC_MODEL_ADAPTIVE									(8)



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//						Defines that are used as error codes or return-codes from ALC-functions
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define ALCOK													(0)
#define ALCERR													(1)
#define ALCERR_REFTM_COORD										(-1)
#define ALCERR_DECTM_COORD										(-2)
#define ALCERR_TMFILL_REF										(-3)
#define ALCERR_TMFILL_DEC										(-4)
#define ALCERR_VOLUME											(-5)
#define ALCERR_TMFILL											(-6)

#define TM_EMPTY												(0)
#define TM_FILLED												(1)

#if( SMRC_SILENT_ALC_4_PSKIP_WITHOUT_SIMILAR_TEMPLATES || SMRC_SILENT_ALC_4_PSKIP_WITHOUT_DISSIMILAR_TEMPLATES)
#define ALCERR_NOTVALID_TMPL_4SKIP										(-7)
int ALC_check_similarity();
int ALC_check_dissimilarity();
int ALC_get_skip_mode();
int ALC_set_skip_mode( int mode, int is_interview);
#endif
#if(SMRC_SILENT_ALC_4_PSKIP		== -1)
void ALC_real_skip(int skip_decision);
#endif

#if(SMRC_ALC_SENSITIVE_LOOPBACK)
int ALC_get_strength( int cur_mb_alc_flag, int neib_mb_alc_flag, int cur_strength, int edge);
#endif

#if(ALC_FLAG_IN_SLICE_HEADER)
int ALC_FrameAdaptability( char* fnc, char* fns, imgpel** curpic, imgpel** synpic, int height, int width, int qp);
#endif//ALC_FLAG_IN_SLICE_HEADER

/*
	Creation of tables, memory allocation etc

	Table with EXP(SIGMA)
*/
void PiLC_Create(void);

/*
	Deinitialization of PiLC buffers
*/
void PiLC_Destroy(void);


XPel PiLC_MxCalc(	XPel* pSrc,
					int YSrc, int XSrc,
					int BlockH, int BlockW,
					int WidthSrc,															
					int stepSrc_x, int stepSrc_y);

int PiLC_GetTMCapacity(void);

void PiLC_TMMakeAveragedHistogram(void);

/*
	Initialization of internal variables, clear of arrays.
*/
void PiLC_TMInit(void);

/*
	Fill elementary sub-block of template based on IsReferenceTemplate ( 1 - reference; 0 - decoded)
	ppFrame - [][] array with data

	int block_y, int block_x - coordinates (in pixels) of template's sub-block start (left-top corner)
	int block_h, int block_w - size (in pixels) of template's sub-block
*/
int PiLC_TMCreateAtom(	XPel **ppFrame, int IsReferenceTemplate,
						int block_y, int block_x,
						int block_h, int block_w,
						int Height, int Width
					);


/*
	Filling of a template buffer block-by-block: either reference or decoded one
	IsReferenceTemplate ( 1 - reference; 0 - decoded)
*/

int PiLC_TMFill(	XPel **ppFrame, int IsReferenceTemplate,
					int block_y, int block_x,									
					int block_h, int block_w,					
					int Height, int Width,
					int template_thickness
				);

// Get corrected version of reference value based on taken template:
//XPel PiLC_TMPelCorHist(	XPel ReferenceVl, XPel *pRefFitlered, int SigmaN);


#if(FIXED_POINT)
	extern int** pExpTableLuma;
  extern int* pTemplExpTable;
#if (0 == USE_SINGLE_MULTIPLIER)
  extern int MULT_256[256*128];
  extern int NonZeroHighestBit[257];
#endif
#else
	extern double** pExpTableLuma;
    extern double* pTemplExpTable;
#endif

extern /*static*/ int RefTemplMin;
extern /*static*/ int RefTemplMax;
extern /*static*/ int SigmaNumber;
extern /*static*/ TMPL_HIST_BIN TemplateHist[256];
extern int CurTemplateCapacity;
extern XPel TemplateRef[MAX_TEMPLATE_VOLUME];
extern XPel TemplateDec[MAX_TEMPLATE_VOLUME];

#if(1 == ALC_OPT1)
extern unsigned short TemplateHistAccRef[256];
extern unsigned short TemplateHistAccDec[256];
extern unsigned char TemplateHistVolume[256];
#elif (2 == ALC_OPT1)
extern unsigned short TemplateHistAccRef[256];
extern unsigned short TemplateHistAccDec[256];
extern unsigned char TemplateHistVolume[256];
	#if (LST_IMPL_OF_ACC)
	//Oct'1 2012: Mike, for emulation of a lists
	extern unsigned short* pPointer2CellsAccRef[256];
	extern unsigned short* pPointer2CellsAccDec[256];
	extern unsigned short TemplateHistVl[256];
	extern int TemlplateLST_Vol;
  extern int TemplateTryMark;
  extern int TemplateTryMarkArray[256];
	#endif
#endif

#if (USE_TRY_MARK_ALREADY_PROCESSED_ALC)
extern int TemplateTryMarkAlreadyProcessed;
#endif

#if (1 == USE_SINGLE_MULTIPLIER || 2 == USE_SINGLE_MULTIPLIER || 1)
extern int ref_sum;
extern int dec_sum;
#endif

#if(ALC_SPEED_OPT)
	extern char Template_visit[256];
  extern short AlreadyProcessed[256];
#endif

/*
	This Function makes correction of input reference value ReferenceVl based on two types of models:

	Multiplicative mode: Y = X * C	

	in case of additive model, pRefFitlered value returns "filtered" value by means of weights calculated over reference template and 
	based on ReferenceVl

	SigmaN - number of Sigma Table used for smoothing

	Default values:	
	SigmaN = 0


*/
//XPel PiLC_TMPelCorHist(	XPel ReferenceVl, XPel *pRefFitlered, int SigmaN)
static XPel PiLC_TMPelCorHist(	XPel ReferenceVl)
{
#if(FIXED_POINT)
	int Ref_Ref = 0;
	int Ref_Dec = 0;
	int Wk = 0;

//    int* pTemplExpTable;
#else
	double Ref_Ref = 0;
	double Ref_Dec = 0;
	double Wk = 0;
	//double WGlobal;
//    double* pTemplExpTable;
#endif
	int delta;
//	int delta_sum;
	int i;
	int rec_vl;
    TMPL_HIST_BIN *ptempHist_bin;

#if(SMRC_ALC_NO_LUMA_COMPENSATION)
	return ReferenceVl;
#endif

#if(ALC_SPEED_OPT)
// early termination in case of ReferenceVl was corrected in early stage.
	if(Template_visit[ReferenceVl] != 0)
	{
		return AlreadyProcessed[ReferenceVl];
	}
#endif

  ptempHist_bin = &(TemplateHist[RefTemplMin - 1]);

	//cycle over all the range of histogram:
#if(!ALC_SPEED_OPT)
	 for(i=0; i < (256 >> AVERAGED_FACTOR_SH); ++i)
#else
	for(i=RefTemplMin; i <= RefTemplMax; ++i)
#endif
	{
		#if(SAVE_REF_MEAN_4_EACH_BIN)
			int i_rec = (TemplateHist[i].acc_ref + TemplateHist[i].acc_volume/2)/TemplateHist[i].acc_volume;
		#else
       #if (AVERAGED_FACTOR_SH)
			int i_rec = (i << AVERAGED_FACTOR_SH) + AVERAGED_FACTOR_ROUNDING;
       #else
            int i_rec  = i;
       #endif
		#endif

        //ptempHist_bin = &(TemplateHist[i]);
          ++ptempHist_bin;

		if (ptempHist_bin->acc_volume)
		{
#if (EXP_TABLE_HALF)
			delta = abs(ReferenceVl - i_rec);
#else            
      delta = iabs(ReferenceVl - i_rec);
#endif      
      if (delta > REF_REF_LUMA_DIF_THRESHOLD)
        continue;
#if ( 0 == FIXED_UNIT_WEIGHT)
      Wk = pTemplExpTable[delta];
#if(SAVE_REF_MEAN_4_EACH_BIN)
        Ref_Ref += TemplateHist[i].acc_ref * Wk;
#else
        #if(USE_APPROXIMATED_REF_ACC)
        Ref_Ref += i_rec * Wk * TemplateHist[i].acc_volume;
        #else
        Ref_Ref += ptempHist_bin->acc_ref * Wk;
#endif
#endif
        Ref_Dec += ptempHist_bin->acc * Wk;            
		}
	}

#if(FIXED_POINT)
	Ref_Dec >>= FIXED_POINT_INTER_SHIFT;
	Ref_Ref >>= FIXED_POINT_INTER_SHIFT;
#endif

	if (Ref_Ref)
		rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref/2)) / Ref_Ref);
	else
		rec_vl = (int)ReferenceVl;

#if(ALC_SPEED_OPT)
  Template_visit[ReferenceVl] = 1;
  AlreadyProcessed[ReferenceVl] = rec_vl = rec_vl > 255 ? 255 : rec_vl;
#else
	rec_vl = (XPel)CLIP(rec_vl, 0, 255);
#endif
	return (XPel)rec_vl;
#elif ( 1 == FIXED_UNIT_WEIGHT)
#if(SAVE_REF_MEAN_4_EACH_BIN)
        Ref_Ref += TemplateHist[i].acc_ref;
#else
    #if(USE_APPROXIMATED_REF_ACC)
  Ref_Ref += i_rec * TemplateHist[i].acc_volume;
    #else
  Ref_Ref += ptempHist_bin->acc_ref;
    #endif
#endif
  Ref_Dec += ptempHist_bin->acc;            
		}
	}
// if FIXED_UNIT_WEIGHT, then no internal increase of bit-depth
	if (Ref_Ref)
		rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref>>1)) / Ref_Ref);
	else
		return (XPel)ReferenceVl;

#if(ALC_SPEED_OPT)
	//Template_visit[ReferenceVl] = rec_vl = (XPel)CLIP(rec_vl, 0, 255);
  Template_visit[ReferenceVl] = 1;
  AlreadyProcessed[ReferenceVl] = rec_vl = rec_vl > 255 ? 255 : rec_vl;
#else
	rec_vl = (XPel)CLIP(rec_vl, 0, 255);
#endif
	return (XPel)rec_vl;
#endif
}

#if(1 == ALC_OPT1)
//XPel PiLC_TMPelCorHist(	XPel ReferenceVl, XPel *pRefFitlered, int SigmaN)
static void PiLC_TMPelCorHist_2DArray(	XPel **ppIn, XPel **ppOut, int YIn, int XIn, int YOut, int XOut, int h, int w)
{
#if(FIXED_POINT)
	int Ref_Ref = 0;
	int Ref_Dec = 0;
	int Wk = 0;

//    int* pTemplExpTable;
#else
	double Ref_Ref = 0;
	double Ref_Dec = 0;
	double Wk = 0;
	//double WGlobal;
//    double* pTemplExpTable;
#endif
	int delta;
//	int delta_sum;
	int i, k, m, k1, m1;
	int rec_vl, ReferenceVl;
  TMPL_HIST_BIN *ptempHist_bin;

  #if(SMRC_ALC_NO_LUMA_COMPENSATION)
 for (k = YOut, k1 = YIn; k < (YOut + h); ++k, ++k1)
  for (m = XOut, m1 = XIn; m < (XOut + w); ++m, ++m1)
  {
    ppOut[k][m] = ppIn[k1][m1];
  }
  #endif
  for (k = YOut, k1 = YIn; k < (YOut + h); ++k, ++k1)
  for (m = XOut, m1 = XIn; m < (XOut + w); ++m, ++m1)
  {
    ReferenceVl = ppIn[k1][m1];
  #if(ALC_SPEED_OPT)
  // early termination in case of ReferenceVl was corrected in early stage.
	  if(Template_visit[ReferenceVl] != 0)
	  {
		  ppOut[k][m] = AlreadyProcessed[ReferenceVl];
      continue;
	  }    
  #endif

    // Initialization!
    Ref_Ref = 0;
    Ref_Dec = 0;
    //cycle over all the range of histogram:
  #if(!ALC_SPEED_OPT)
	   for(i=0; i < (256 >> AVERAGED_FACTOR_SH); ++i)
  #else
	  for(i = RefTemplMin; i <= RefTemplMax; ++i)
  #endif
    {
      if (TemplateHistVolume[i] )
		  {
  #if(SAVE_REF_MEAN_4_EACH_BIN)
//			int i_rec = (TemplateHist[i].acc_ref + TemplateHist[i].acc_volume/2)/TemplateHist[i].acc_volume;
			int i_rec = (TemplateHistAccRef[i] + (TemplateHistVolume[i]>>1)) / TemplateHistVolume[i];
  #else
    #if (AVERAGED_FACTOR_SH)
			int i_rec = (i << AVERAGED_FACTOR_SH) + AVERAGED_FACTOR_ROUNDING;
    #else
      int i_rec  = i;
    #endif
  #endif
  #if (EXP_TABLE_HALF)
			  delta = abs(ReferenceVl - i_rec);
  #else            
        delta = (ReferenceVl - i_rec);
  #endif      
        Wk = pTemplExpTable[delta];
        if (0 == Wk)
          continue;
  #if ( 0 == FIXED_UNIT_WEIGHT)        
  #if(SAVE_REF_MEAN_4_EACH_BIN)
        Ref_Ref += TemplateHistAccRef[i] * Wk;
  #else
    #if(USE_APPROXIMATED_REF_ACC)
        Ref_Ref += i_rec * Wk * TemplateHistAccRef[i];
    #else
//          Ref_Ref += ptempHist_bin->acc_ref * Wk;
        Ref_Ref += TemplateHistAccRef[i] * Wk;
    #endif
  #endif
//          Ref_Dec += ptempHist_bin->acc * Wk;            
        Ref_Dec += TemplateHistAccDec[i] * Wk;
      }
    }
  #if(FIXED_POINT)
    Ref_Dec >>= FIXED_POINT_INTER_SHIFT;
    Ref_Ref >>= FIXED_POINT_INTER_SHIFT;
  #endif
  #elif ( 1 == FIXED_UNIT_WEIGHT)
   #if(SAVE_REF_MEAN_4_EACH_BIN)
        Ref_Ref += TemplateHistAccRef[i];
  #else
    #if(USE_APPROXIMATED_REF_ACC)
        Ref_Ref += i_rec * TemplateHistAccRef[i];
    #else
        Ref_Ref += TemplateHistAccRef[i];
    #endif
  #endif
        Ref_Dec += TemplateHistAccDec[i];
		  }
    }
  #endif

	  if (Ref_Ref)
		  rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref>>1)) / Ref_Ref);
	  else
		  rec_vl = (int)ReferenceVl;

  #if(ALC_SPEED_OPT)
    Template_visit[ReferenceVl] = 1;
    AlreadyProcessed[ReferenceVl] = rec_vl = rec_vl > 255 ? 255 : rec_vl;
  #else
	  rec_vl = (XPel)CLIP(rec_vl, 0, 255);
  #endif
	  ppOut[k][m] = (XPel)rec_vl; 
    }
}

//XPel PiLC_TMPelCorHist(	XPel ReferenceVl, XPel *pRefFitlered, int SigmaN)
static void PiLC_TMPelCorHist_1DArray(	XPel *pIn, XPel *pOut, int StrideIn, int StrideOut, int h, int w)
{
#if(FIXED_POINT)k;
	int Ref_Ref = 0;
	int Ref_Dec = 0;
	int Wk = 0;

//    int* pTemplExpTable;
#else
	double Ref_Ref = 0;
	double Ref_Dec = 0;
	double Wk = 0;
	//double WGlobal;
//    double* pTemplExpTable;
#endif
	int delta;
//	int delta_sum;
	int i, k, m, k1, m1;
	int rec_vl, ReferenceVl;
  TMPL_HIST_BIN *ptempHist_bin;

  #if(SMRC_ALC_NO_LUMA_COMPENSATION)
 for (k = YOut, k1 = YIn; k < (YOut + h); ++k, ++k1)
  for (m = XOut, m1 = XIn; m < (XOut + w); ++m, ++m1)
  {
    ppOut[k][m] = ppIn[k1][m1];
  }
  #endif
  for (k = 0; k < h; ++k)
  {
    for (m = 0; m < w; ++m)
    {
      ReferenceVl = pIn[m];
    #if(ALC_SPEED_OPT)
    // early termination in case of ReferenceVl was corrected in early stage.
	    if(Template_visit[ReferenceVl] != 0)
	    {
		    pOut[m] = AlreadyProcessed[ReferenceVl];
        continue;
	    }    
    #endif

      // Initialization!
      Ref_Ref = 0;
	    Ref_Dec = 0;
//      ptempHist_bin = &(TemplateHist[RefTemplMin - 1]);

	    //cycle over all the range of histogram:
    #if(!ALC_SPEED_OPT)
	     for(i=0; i < (256 >> AVERAGED_FACTOR_SH); ++i)
    #else
	    for(i = RefTemplMin; i <= RefTemplMax; ++i)
    #endif
	    {
        if ( TemplateHistVolume[i] )
		    {
    #if(SAVE_REF_MEAN_4_EACH_BIN)
			  int i_rec = (TemplateHistAccRef[i] + (TemplateHistVolume[i]>>1)) / TemplateHistVolume[i];
    #else
      #if (AVERAGED_FACTOR_SH)
			  int i_rec = (i << AVERAGED_FACTOR_SH) + AVERAGED_FACTOR_ROUNDING;
      #else
        int i_rec  = i;
      #endif
    #endif
    #if (EXP_TABLE_HALF)
          delta = abs(ReferenceVl - i_rec);
    #else            
          delta = ReferenceVl - i_rec;
    #endif
          Wk = pTemplExpTable[delta];
          if (0 == Wk)
            continue;
    #if ( 0 == FIXED_UNIT_WEIGHT)
//////////////////////////////////////////////////////////////////////////////////////////
    #if(SAVE_REF_MEAN_4_EACH_BIN)
            Ref_Ref += TemplateHistAccRef[i] * Wk;
    #else
            #if(USE_APPROXIMATED_REF_ACC)
            Ref_Ref += i_rec * Wk * TemplateHistVolume[i];
            #else
            //Ref_Ref += ptempHist_bin->acc_ref * Wk;
            Ref_Ref += TemplateHistAccRef[i] * Wk;
            #endif
    #endif
//            Ref_Dec += ptempHist_bin->acc * Wk;            
            Ref_Dec += TemplateHistAccDec[i] * Wk;
		    }
	    }
    #if(FIXED_POINT)
	    Ref_Dec >>= FIXED_POINT_INTER_SHIFT;
	    Ref_Ref >>= FIXED_POINT_INTER_SHIFT;
    #endif

    #elif ( 1 == FIXED_UNIT_WEIGHT)
    #if(SAVE_REF_MEAN_4_EACH_BIN)
          //Ref_Ref += ptempHist_bin->acc_ref;
          Ref_Ref += TemplateHistAccRef[i];
    #else
        #if(USE_APPROXIMATED_REF_ACC)
          //Ref_Ref += i_rec * TemplateHist[i].acc_volume;
          Ref_Ref += i_rec * TemplateHistVolume[i];
        #else
          Ref_Ref += TemplateHistAccRef[i];
        #endif
    #endif
          Ref_Dec += TemplateHistAccDec[i];
		    }
	    }
    #endif

	    if (Ref_Ref)
		    rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref>>1)) / Ref_Ref);
	    else
		    rec_vl = (int)ReferenceVl;

    #if(ALC_SPEED_OPT)
	    Template_visit[ReferenceVl] = 1;
      AlreadyProcessed[ReferenceVl] = rec_vl = rec_vl > 255 ? 255 : rec_vl;
    #else
	    rec_vl = (XPel)CLIP(rec_vl, 0, 255);
    #endif
	    pOut[m] = (XPel)rec_vl;   
    }
    pOut += StrideOut;
    pIn += StrideIn;
  }
}
#elif (2 == ALC_OPT1)

extern XPel* pTM_buf44;
//XPel PiLC_TMPelCorHist(	XPel ReferenceVl, XPel *pRefFitlered, int SigmaN)
static void PiLC_TMPelCorHist_2DArray(	XPel **ppIn, XPel **ppOut,/* int YIn, int XIn, int YOut, */int XOut, int h, int w)
{
  #if(FIXED_POINT)
	int Ref_Ref;
	int Ref_Dec;
  int RefVl_mul_mult_factor;
  int mult_factor;
  int Ref_ref_256Mul;
  int mult_factorx255;
  //int Ref_Ref_div_2;
	int Wk = 0;
  int Wk1 = 0;
#else
	double Ref_Ref;
	double Ref_Dec;
	double Wk = 0;
#endif
	int delta;
	int i, k, m;
	int rec_vl, ReferenceVl;
  XPel* pTempIn;
  XPel* pTempOut;
  int stride_in, stride_out;
  int Min_based_on_ref, Max_based_on_ref;
  int *pTemp;
  int RefTemplMin_plus_REF_REF_TH;
  int RefTemplMax_minus_REF_REF_TH;  
  int b;
#if (0 == USE_SINGLE_MULTIPLIER)
    int InpMin, InpMax;
#endif
/*
#if (EARLY_ALC_OFF_DETECTION)
int hist_dif;
#endif
*/

#if (1 == USE_SINGLE_MULTIPLIER)
  Ref_Ref = ref_sum;
  Ref_Dec = dec_sum;
/*
  //mult_factor = ((1 << SINGL_MULT_FACT_PREC) * Ref_Dec)/Ref_Ref;  
	if (Ref_Ref)
	  mult_factor = ((1 << SINGL_MULT_FACT_PREC) * (unsigned int)Ref_Dec + (unsigned int)(Ref_Ref>>1))/(unsigned int)Ref_Ref;  
  else
  {
    mult_factor = 0;
#if (EARLY_ALC_OFF_DETECTION)
    // in order to stimulate copying in the case of zero reference
    dec_sum = ref_sum;
#endif
  }
*/
   mult_factor = ((1 << SINGL_MULT_FACT_PREC) * (unsigned int)Ref_Dec + (unsigned int)(Ref_Ref>>1))/(unsigned int)Ref_Ref;  
//  mult_factorx255 = 255 << SINGL_MULT_FACT_PREC;

  //Ref_Ref_div_2 =  (1 << (SINGL_MULT_FACT_PREC - 1)) ;
#elif (2 == USE_SINGLE_MULTIPLIER)
  Ref_Ref = ref_sum;
  Ref_Dec = dec_sum;
#endif

#if(SMRC_ALC_NO_LUMA_COMPENSATION)
 for (k = YOut, k1 = YIn; k < (YOut + h); ++k, ++k1)
  for (m = XOut, m1 = XIn; m < (XOut + w); ++m, ++m1)
    ppOut[k][m] = ppIn[k1][m1];
	return;
#endif    
  //stride between two adjacent lines:
  //stride_in = &(ppIn[YIn+1][XIn]) - &(ppIn[YIn][XIn]);
  //stride_in -= w;
  //stride_out = &(ppOut[YOut+1][XOut]) - &(ppOut[YOut][XOut]);
  //stride_out -= w;
	stride_out = MB_BLOCK_SIZE - w;

  //pTempIn = &(ppIn[YIn][XIn]);

#if( 0 == SMRC_ALC_INTMV_REFTEMPLATE)
	pTempIn = pTM_buf44;
	stride_in =16 + MAX_TEMPLATE_SIZE - w;
#else
	pTempIn = *ppIn;
	stride_in = MB_BLOCK_SIZE - w;
#endif
  //pTempOut = & (ppOut[YOut][XOut]);
	pTempOut = *ppOut+XOut;

	#if (0 == AVERAGED_FACTOR_SH && 0 == LST_IMPL_OF_ACC)
  RefTemplMin_plus_REF_REF_TH = RefTemplMin + REF_REF_LUMA_DIF_THRESHOLD;
  RefTemplMax_minus_REF_REF_TH = RefTemplMax - REF_REF_LUMA_DIF_THRESHOLD;
#endif

#if (0 == USE_SINGLE_MULTIPLIER)
  InpMin = 256;
  InpMax = -1;
#endif

#if (LST_IMPL_OF_ACC && EARLY_ALC_OFF_DETECTION && 0 == USE_SINGLE_MULTIPLIER)
  //calculating of red/dec sums can be done here
  ref_sum = dec_sum = 0;
  for(i = 0; i < TemlplateLST_Vol; ++i) 
  {
    ref_sum += TemplateHistAccRef[i];
    dec_sum += TemplateHistAccDec[i];
  }
#endif

#if (EARLY_ALC_OFF_DETECTION)
//  hist_dif = iabs( ref_sum - dec_sum);
//  hist_dif>>=EARLY_ALC_OFF_DETECTION_THRESHOLD;

  ref_sum >>=EARLY_ALC_OFF_DETECTION_THRESHOLD;
  dec_sum >>=EARLY_ALC_OFF_DETECTION_THRESHOLD;

  // in order to have more correct rounding
//  ref_sum = (ref_sum + (1 << EARLY_ALC_OFF_DETECTION_THRESHOLD-1)) >> EARLY_ALC_OFF_DETECTION_THRESHOLD;
//  dec_sum = (dec_sum + (1 << EARLY_ALC_OFF_DETECTION_THRESHOLD-1)) >> EARLY_ALC_OFF_DETECTION_THRESHOLD;

  if (ref_sum == dec_sum)
//  if (0 == hist_dif)
  {
     for (k = 0/*YOut*/; k < (/*YOut + */h); ++k)
    {
      memcpy(pTempOut, pTempIn, sizeof(XPel) * w);
      /*
      for (m = XOut; m < (XOut + w); ++m)
      {
        *pTempOut++ = *pTempIn++;;
      }
      */
      pTempIn += (stride_in + w);
      pTempOut += (stride_out + w);
     }
     return;
  }
#endif

  for (k = 0/*YOut*/; k < (/*YOut + */h); ++k)
  {
  for (m = XOut; m < (XOut + w); ++m)
  {
    ReferenceVl = *pTempIn++;
#if (0 == USE_SINGLE_MULTIPLIER)
  // early termination in case of ReferenceVl was corrected in early stage.
    if ( AlreadyProcessed[ReferenceVl] != -1)
	  {
      *pTempOut++ = AlreadyProcessed[ReferenceVl];
      continue;
	  }    

    // Initialization! 1 - in order to avoid division by zero. This is not stricktly correct but quite good approximaation
#if(FIXED_POINT)
#if(1 == NO_DIVISION_CORRECTION_ALC)
      Ref_Dec = 0;
      Ref_Ref = 0;
#else
#if (0 == ALC_OPT_REF_REF0_BEHAVIOR)
      Ref_Ref = (1<<FIXED_POINT_INTER_SHIFT); 
      Ref_Dec = (1<<FIXED_POINT_INTER_SHIFT);
#else
      Ref_Dec = 0;
      Ref_Ref = 0;
#endif
#endif
#else
      Ref_Dec = 0.0;
      Ref_Ref = 0.0;
#endif
	#if (0 == LST_IMPL_OF_ACC)
    //let detect min and max limits based on reference:
#if (AVERAGED_FACTOR_SH)
    Min_based_on_ref = (ReferenceVl - REF_REF_LUMA_DIF_THRESHOLD) >> AVERAGED_FACTOR_SH;
    Max_based_on_ref = (ReferenceVl + REF_REF_LUMA_DIF_THRESHOLD) >> AVERAGED_FACTOR_SH;
    if (Min_based_on_ref < RefTemplMin) Min_based_on_ref = RefTemplMin;
    if (Max_based_on_ref > RefTemplMax) Max_based_on_ref = RefTemplMax;
		#else//AVERAGED_FACTOR_SH
    // we can calculate it outside of this loop
    if (ReferenceVl < RefTemplMin_plus_REF_REF_TH)       
      Min_based_on_ref = RefTemplMin;
    else
      Min_based_on_ref = ReferenceVl - REF_REF_LUMA_DIF_THRESHOLD;

    if (ReferenceVl > RefTemplMax_minus_REF_REF_TH)       
      Max_based_on_ref = RefTemplMax;
    else
      Max_based_on_ref = ReferenceVl + REF_REF_LUMA_DIF_THRESHOLD;
		#endif//AVERAGED_FACTOR_SH
	#endif//LST_IMPL_OF_ACC

    //cycle over all the range of histogram:
	#if(0 == LST_IMPL_OF_ACC)
		#if (0 == FIXED_UNIT_WEIGHT && !EXP_TABLE_HALF)
		#if AVERAGED_FACTOR_SH
    pTemp = pTemplExpTable + ReferenceVl - (Min_based_on_ref<<AVERAGED_FACTOR_SH) - AVERAGED_FACTOR_ROUNDING;
#else    
    pTemp = pTemplExpTable + ReferenceVl - Min_based_on_ref;
#endif
		#endif

    for(i = Min_based_on_ref; i <= Max_based_on_ref; ++i)    
	#else
#if(AVERAGED_FACTOR_SH)
	 pTemp = pTemplExpTable + ReferenceVl- AVERAGED_FACTOR_ROUNDING;
#else
  pTemp = pTemplExpTable + ReferenceVl;
#endif
	 for(i = 0; i < TemlplateLST_Vol; ++i) 
	#endif
		  {
			#if(0 == LST_IMPL_OF_ACC)
      Wk = *pTemp;
			#else
				Wk = *(pTemp - TemplateHistVl[i]);
			#endif
      
  #if(SAVE_REF_MEAN_4_EACH_BIN)
        Ref_Ref += TemplateHistAccRef[i] * Wk;
  #else
    #if(USE_APPROXIMATED_REF_ACC)
        Ref_Ref += i_rec * Wk * TemplateHistAccRef[i];
    #else
        Ref_Ref += TemplateHistAccRef[i] * Wk;
    #endif
  #endif
        Ref_Dec += TemplateHistAccDec[i] * Wk;

			#if(0 == LST_IMPL_OF_ACC)
#if (0 == AVERAGED_FACTOR_SH)
      --pTemp;
#else
      pTemp = pTemp - (1<< AVERAGED_FACTOR_SH);
#endif
			#endif//(0 == LST_IMPL_OF_ACC)
    }

#if(1 == NO_DIVISION_CORRECTION_ALC)
    #if(FIXED_POINT)    
   Ref_Dec = (Ref_Dec + (1<<FIXED_POINT_PRESISION_SHIFT-1)) >> FIXED_POINT_PRESISION_SHIFT;
   Ref_Ref = (Ref_Ref + (1<<FIXED_POINT_PRESISION_SHIFT-1)) >> FIXED_POINT_PRESISION_SHIFT;
    #endif

   //Ref_ref_256Mul = Ref_Ref >> PRELIM_QUANT_FOR_INT_DIVISION;
   Ref_ref_256Mul = NonZeroHighestBit[Ref_Ref >> PRELIM_QUANT_FOR_INT_DIVISION];
/*
   if (0 == Ref_ref_256Mul)
   {
      Ref_Ref = MULT_256[Ref_Ref];
      rec_vl = (ReferenceVl * Ref_Dec * Ref_Ref + (1 << PRECISION_FOR_INT_DIVISION-1)) >> PRECISION_FOR_INT_DIVISION;
   }
   else
*/
   {
     //Ref_Ref >>= (NonZeroHighestBit[Ref_ref_256Mul]/* + 1*/);
     //Ref_Dec >>= (NonZeroHighestBit[Ref_ref_256Mul]/* + 1*/);
     Ref_Ref >>= (Ref_ref_256Mul);
     Ref_Dec >>= (Ref_ref_256Mul);
     Ref_Ref = MULT_256[Ref_Ref];
     rec_vl = ((unsigned int)ReferenceVl * (unsigned int)Ref_Dec * (unsigned int)Ref_Ref + (1 << PRECISION_FOR_INT_DIVISION-1)) >> PRECISION_FOR_INT_DIVISION;
   }
#else
    Ref_Dec >>= FIXED_POINT_INTER_SHIFT;
    Ref_Ref >>= FIXED_POINT_INTER_SHIFT;
		#if(0 == ALC_OPT_REF_REF0_BEHAVIOR)
		rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref>>1)) / Ref_Ref);
		#else
		if (Ref_Ref)
			rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref>>1)) / Ref_Ref);
		else
			rec_vl = (int)ReferenceVl;
    #endif
#endif
    if (rec_vl > 255) 
      rec_vl = 255;

#elif (1 == USE_SINGLE_MULTIPLIER)
/*
    RefVl_mul_mult_factor = ReferenceVl * mult_factor + (1<<(SINGL_MULT_FACT_PREC-1));
    if (RefVl_mul_mult_factor >= MULT_FACTOR_X_255)
      rec_vl = 255;
    else
		  rec_vl = (int)( RefVl_mul_mult_factor >> SINGL_MULT_FACT_PREC);
*/
    rec_vl = (int)( (ReferenceVl * mult_factor + (1<<(SINGL_MULT_FACT_PREC-1))) >> SINGL_MULT_FACT_PREC);
      if (rec_vl > 255) rec_vl = 255;

#elif (2 == USE_SINGLE_MULTIPLIER)
      //this is to avoid additional check of zrro/non-zero value of ref_ref
      rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref>>1)) / Ref_Ref);
      if (rec_vl > 255) 
          rec_vl = 255;
#endif
      
      //b = 255 - rec_vl;
      //b = (b >> 8);
      //rec_vl = (rec_vl | b) & (0xFF);
      
#if (0 == USE_SINGLE_MULTIPLIER)
      AlreadyProcessed[ReferenceVl] = rec_vl;

      //Get ranges of input data
      if (ReferenceVl > InpMax)
        InpMax = ReferenceVl;
      if (ReferenceVl < InpMin)
        InpMin = ReferenceVl;
#endif
      *pTempOut++ = (XPel)rec_vl;
    }  
  pTempIn += stride_in;
  pTempOut += stride_out;
  }
#if (0 == USE_SINGLE_MULTIPLIER)
  //clear only neccessary elements
  if (-1 != InpMax)  
    memset(AlreadyProcessed + InpMin, -1, sizeof(short)*(1 + InpMax - InpMin));
#endif
}

//XPel PiLC_TMPelCorHist(	XPel ReferenceVl, XPel *pRefFitlered, int SigmaN)
static void PiLC_TMPelCorHist_1DArray(	XPel *pIn, XPel *pOut, int StrideIn, int StrideOut, int h, int w)
{
#if(FIXED_POINT)
	volatile int Ref_Ref = 0;
	volatile int Ref_Dec = 0;
	int Wk = 0;
  int mult_factor;
  int mult_factorx255;
  int Ref_ref_256Mul;
  int RefVl_mul_mult_factor;
  //int Ref_Ref_div_2;
//    int* pTemplExpTable;
#else
	double Ref_Ref = 0;
	double Ref_Dec = 0;
	double Wk = 0;
	//double WGlobal;
//    double* pTemplExpTable;
#endif
	int delta;
//	int delta_sum;
	int i, k, m, k1, m1;
	int rec_vl, ReferenceVl, b;
  int Min_based_on_ref, Max_based_on_ref;
  int* pTemp;
  int RefTemplMin_plus_REF_REF_TH;
  int RefTemplMax_minus_REF_REF_TH;
/*
#if (EARLY_ALC_OFF_DETECTION)
  int hist_dif;
#endif
*/
#if (0 == USE_SINGLE_MULTIPLIER)
  int InpMin, InpMax;
#endif
#if (1 == USE_SINGLE_MULTIPLIER )
  Ref_Ref = ref_sum;
  Ref_Dec = dec_sum;

  //mult_factor = ((1 << SINGL_MULT_FACT_PREC) * Ref_Dec)/Ref_Ref;
  /*
  if (Ref_Ref)
	  mult_factor = ((1 << SINGL_MULT_FACT_PREC) * (unsigned int)Ref_Dec + (unsigned int)(Ref_Ref>>1))/(unsigned int)Ref_Ref;  
  else
  {
    mult_factor = 0;
#if (EARLY_ALC_OFF_DETECTION)
    // in order to stimulate copying in the case of zero reference
    dec_sum = ref_sum;
#endif
    }
*/
  mult_factor = ((1 << SINGL_MULT_FACT_PREC) * (unsigned int)Ref_Dec + (unsigned int)(Ref_Ref>>1))/(unsigned int)Ref_Ref;  
//  mult_factorx255 = 255 << SINGL_MULT_FACT_PREC;

  //Ref_Ref_div_2 =  (1 << (SINGL_MULT_FACT_PREC - 1)) ;
#elif (2 == USE_SINGLE_MULTIPLIER )
  Ref_Ref = ref_sum;
  Ref_Dec = dec_sum;
#endif

#if (0 == AVERAGED_FACTOR_SH && 0 == LST_IMPL_OF_ACC)
  RefTemplMin_plus_REF_REF_TH = RefTemplMin + REF_REF_LUMA_DIF_THRESHOLD;
  RefTemplMax_minus_REF_REF_TH = RefTemplMax - REF_REF_LUMA_DIF_THRESHOLD;
#endif//(0 == AVERAGED_FACTOR_SH)

#if(SMRC_ALC_NO_LUMA_COMPENSATION)
 for (k = YOut, k1 = YIn; k < (YOut + h); ++k, ++k1)
  for (m = XOut, m1 = XIn; m < (XOut + w); ++m, ++m1)
  {
    ppOut[k][m] = ppIn[k1][m1];
  }
		return;
#endif 

#if (0 == USE_SINGLE_MULTIPLIER)
  InpMin = 256;
  InpMax = -1;
#endif

#if (LST_IMPL_OF_ACC && EARLY_ALC_OFF_DETECTION && 0 == USE_SINGLE_MULTIPLIER)
  //calculating of red/dec sums can be done here
  ref_sum = dec_sum = 0;
  for(i = 0; i < TemlplateLST_Vol; ++i) 
  {
    ref_sum += TemplateHistAccRef[i];
    dec_sum += TemplateHistAccDec[i];
  }
#endif

#if (EARLY_ALC_OFF_DETECTION)
//  hist_dif = iabs( ref_sum - dec_sum);
//  hist_dif>>=EARLY_ALC_OFF_DETECTION_THRESHOLD;

  ref_sum >>=EARLY_ALC_OFF_DETECTION_THRESHOLD;
  dec_sum >>=EARLY_ALC_OFF_DETECTION_THRESHOLD;

  // in order to have more correct rounding
//  ref_sum = (ref_sum + (1 << EARLY_ALC_OFF_DETECTION_THRESHOLD-1)) >> EARLY_ALC_OFF_DETECTION_THRESHOLD;
//  dec_sum = (dec_sum + (1 << EARLY_ALC_OFF_DETECTION_THRESHOLD-1)) >> EARLY_ALC_OFF_DETECTION_THRESHOLD;

  if (ref_sum == dec_sum)
//  if (0 == hist_dif)
  {
    for (k = 0; k < h; ++k)
    {
      memcpy(pOut, pIn, sizeof(XPel) * w);
      /*
      for (m = 0; m < w; ++m)
      {
        pOut[m] = pIn[m];
      }
      */
      pOut += StrideOut;
      pIn += StrideIn;
    }    
    return;
  }
#endif
  for (k = 0; k < h; ++k)
  {
    for (m = 0; m < w; ++m)
    {
      ReferenceVl = pIn[m];
#if (0 == USE_SINGLE_MULTIPLIER)
    // early termination in case of ReferenceVl was corrected in early stage.
      if(AlreadyProcessed[ReferenceVl] != -1)
	    {
		    pOut[m] = AlreadyProcessed[ReferenceVl];
        continue;
	    }    

      // Initialization! 1 - in order to avoid division by zero. This is not stricktly correct but quite good approximaation
#if(FIXED_POINT)
#if(1 == NO_DIVISION_CORRECTION_ALC)
      Ref_Dec = 0;
      Ref_Ref = 0;
#else
#if (0 == ALC_OPT_REF_REF0_BEHAVIOR)
      Ref_Ref = (1<<FIXED_POINT_INTER_SHIFT); 
      Ref_Dec = (1<<FIXED_POINT_INTER_SHIFT);
#else
      Ref_Dec = 0;
      Ref_Ref = 0;
#endif
#endif
#else
      Ref_Dec = 0.0;
      Ref_Ref = 0.0;
#endif

	#if(0 == LST_IMPL_OF_ACC)
    //let detect min and max limits based on reference:
#if (AVERAGED_FACTOR_SH)
    Min_based_on_ref = (ReferenceVl - REF_REF_LUMA_DIF_THRESHOLD) >> AVERAGED_FACTOR_SH;
    Max_based_on_ref = (ReferenceVl + REF_REF_LUMA_DIF_THRESHOLD) >> AVERAGED_FACTOR_SH;
    if (Min_based_on_ref < RefTemplMin) Min_based_on_ref = RefTemplMin;
    if (Max_based_on_ref > RefTemplMax) Max_based_on_ref = RefTemplMax;
		#else//(AVERAGED_FACTOR_SH)
    // we can calculate it outside of this loop
    if (ReferenceVl < RefTemplMin_plus_REF_REF_TH)       
      Min_based_on_ref = RefTemplMin;
    else
      Min_based_on_ref = ReferenceVl - REF_REF_LUMA_DIF_THRESHOLD;

    if (ReferenceVl > RefTemplMax_minus_REF_REF_TH)       
      Max_based_on_ref = RefTemplMax;
    else
      Max_based_on_ref = ReferenceVl + REF_REF_LUMA_DIF_THRESHOLD;
		#endif//(AVERAGED_FACTOR_SH)
	#endif

	#if(0 == LST_IMPL_OF_ACC)
    //cycle over all the range of histogram:
		#if (0 == FIXED_UNIT_WEIGHT && !EXP_TABLE_HALF)
			#if(AVERAGED_FACTOR_SH)
    pTemp = pTemplExpTable + ReferenceVl - (Min_based_on_ref<<AVERAGED_FACTOR_SH)-AVERAGED_FACTOR_ROUNDING;
#else    
    pTemp = pTemplExpTable + ReferenceVl - Min_based_on_ref;
#endif
		#endif

      for(i = Min_based_on_ref; i <= Max_based_on_ref; ++i)    
	#else
#if(AVERAGED_FACTOR_SH)
	 pTemp = pTemplExpTable + ReferenceVl- AVERAGED_FACTOR_ROUNDING;
#else
  pTemp = pTemplExpTable + ReferenceVl;
#endif
	 for(i = 0; i < TemlplateLST_Vol; ++i) 
	#endif
		    {
			#if(0 == LST_IMPL_OF_ACC)
      Wk = *pTemp;
			#else
				Wk = *(pTemp - TemplateHistVl[i]);
			#endif

            #if(USE_APPROXIMATED_REF_ACC)
            Ref_Ref += i_rec * Wk * TemplateHistVolume[i];
            #else
            Ref_Ref += TemplateHistAccRef[i] * Wk;
            #endif

            Ref_Dec += TemplateHistAccDec[i] * Wk;

			#if(0 == LST_IMPL_OF_ACC)
#if (0 == AVERAGED_FACTOR_SH)
      --pTemp;
#else
      pTemp = pTemp - (1<< AVERAGED_FACTOR_SH);
#endif
			#endif
	    }
#if(1 == NO_DIVISION_CORRECTION_ALC)
    #if(FIXED_POINT)    
   Ref_Dec = (Ref_Dec + (1<<FIXED_POINT_PRESISION_SHIFT-1)) >> FIXED_POINT_PRESISION_SHIFT;
   Ref_Ref = (Ref_Ref + (1<<FIXED_POINT_PRESISION_SHIFT-1)) >> FIXED_POINT_PRESISION_SHIFT;
    #endif

   //Ref_ref_256Mul = Ref_Ref >> PRELIM_QUANT_FOR_INT_DIVISION;
   Ref_ref_256Mul = NonZeroHighestBit[Ref_Ref >> PRELIM_QUANT_FOR_INT_DIVISION];
/*
   if (0 == Ref_ref_256Mul)
   {
      Ref_Ref = MULT_256[Ref_Ref];
      rec_vl = (ReferenceVl * Ref_Dec * Ref_Ref + (1 << PRECISION_FOR_INT_DIVISION-1)) >> PRECISION_FOR_INT_DIVISION;
   }
   else
*/
   {
     //Ref_Ref >>= (NonZeroHighestBit[Ref_ref_256Mul]/* + 1*/);
     //Ref_Dec >>= (NonZeroHighestBit[Ref_ref_256Mul]/* + 1*/);
     Ref_Ref >>= (Ref_ref_256Mul);
     Ref_Dec >>= (Ref_ref_256Mul);
     Ref_Ref = MULT_256[Ref_Ref];
     rec_vl = ((unsigned int)ReferenceVl * (unsigned int)Ref_Dec * (unsigned int)Ref_Ref + (1 << PRECISION_FOR_INT_DIVISION-1)) >> PRECISION_FOR_INT_DIVISION;
   }
#else
    Ref_Dec >>= FIXED_POINT_INTER_SHIFT;
    Ref_Ref >>= FIXED_POINT_INTER_SHIFT;
		#if(0 == ALC_OPT_REF_REF0_BEHAVIOR)
		rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref>>1)) / Ref_Ref);
		#else
		if (Ref_Ref)
			rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref>>1)) / Ref_Ref);
		else
			rec_vl = (int)ReferenceVl;
    #endif
#endif
      if (rec_vl > 255) rec_vl = 255;
#elif (1 == USE_SINGLE_MULTIPLIER)
/*
    RefVl_mul_mult_factor = ReferenceVl * mult_factor + (1<<(SINGL_MULT_FACT_PREC-1));
    if (RefVl_mul_mult_factor >= MULT_FACTOR_X_255)
      rec_vl = 255;
    else
		  rec_vl = (int)( RefVl_mul_mult_factor >> SINGL_MULT_FACT_PREC);
*/

    rec_vl = (int)( (ReferenceVl * mult_factor + (1<<(SINGL_MULT_FACT_PREC-1))) >> SINGL_MULT_FACT_PREC);
      if (rec_vl > 255) rec_vl = 255;


#elif (2 == USE_SINGLE_MULTIPLIER)
      //this is to avoid additional check of zrro/non-zero value of ref_ref
    rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref>>1)) / Ref_Ref);
    if (rec_vl > 255) rec_vl = 255;
#endif

/*
//this is how to check saturaion w/o if
      b = 255 - rec_vl;
      b = (b >> 8);
      rec_vl = (rec_vl | b) & (0xFF);
*/
#if (0 == USE_SINGLE_MULTIPLIER)
      AlreadyProcessed[ReferenceVl] = rec_vl;

//Get ranges of input data
      if (ReferenceVl > InpMax)
        InpMax = ReferenceVl;
      if (ReferenceVl < InpMin)
        InpMin = ReferenceVl;

#endif
	    pOut[m] = (XPel)rec_vl;   
    }
    pOut += StrideOut;
    pIn += StrideIn;
  }
#if (0 == USE_SINGLE_MULTIPLIER)
  //clear only neccessary elements
  if (-1 != InpMax)  
    memset(AlreadyProcessed + InpMin, -1, sizeof(short)*(1 + InpMax - InpMin));
#endif
}
#endif

// output template pixels data to file
void PiLC_TMOutput2File(void);


/*

***************************FUNCTIONS THAT ARE TO BE USED AND TO BE CALLED IN THE CODER************************************

*/

void ALC_Create(int FrameH, int FrameW); // with memory allocation for internal frame buffer. Can be used for debug writings and visualization
void ALC_CreateSimple(); //No internal frame memory allocation.

void ALC_set_tmpl_types( int* pPartitions, int num);
void ALC_Destroy();


/*
	This function takes pixels from reference and decoded template areas in respect of pixel positions of left-top corners:
	- RefTM_startY, RefTM_startX : left-top corner of a block nearby whom template can be taken
	- DecTM_startY, DecTM_startX : left-top corner of a block nearby whom template can be taken

	Blk_height - total height of the block inside a template
	Blk_width - total width of the block inside a template

	return 0 if procedure was succeed.
	Non-zero value in case of any error.

	Descriptions of error values:

*/
int ALC_GetTM(	XPel **ppRef, int RefTM_startY, int RefTM_startX, 
				XPel **ppDec, int DecTM_startY, int DecTM_startX, 
				int Blk_height, int Blk_width, int TM_size,
				int FrameH, int FrameW);

#if(SMRC_3DV && 1 == SMRC_ALC_AFTER_WP)
int ALC_after_WP(	XPel **ppRef, int RefTM_startY, int RefTM_startX, 
				XPel **ppDec, int DecTM_startY, int DecTM_startX, 
				int Blk_height, int Blk_width, int TM_size,
				int FrameH, int FrameW,int max_imgpel_value,
				short wp, short offset, short wp_round, short weight_denom, imgpel** mb_pred, int block_x);
#endif

/*
	Main Function that does correction for a block based on previously prepared template data
*/
int ALC_DoCorrect(	XPel **ppRef, XPel  *pDst, 
					int RefTM_startY, int RefTM_startX, 
					int Blk_height, int Blk_width, 
					int FrameH, int FrameW, int ALCType);


Boolean IsTMFilled();

//Functions for verification of ALC status ( either it should be turned-on either not) and functions for TurnON/TurnOFF
Boolean IsALC_TurnON();

Boolean IsALC_TurnON_and_TMFilled();

void ALC_TurnOFF();

void ALC_TurnON();


//Functions that return pointers to the internal buffers that are used for TM taking at the decoder-side in case if simple extraction of it is not possible
XPel** ALC_RetTMHorbuf();
XPel** ALC_RetTMVerbuf();
XPel** ALC_RetTM_buf();
int** ALC_RetTM_tempbuf();
#if( 0 != SMRC_SILENT_ALC_4_PSKIP)
	void ALC_save_pred( XPel ** pred);
	int ALC_get_best_pred( XPel ** orig, XPel ** pred, int mb_x);
#endif

//functions for debug
void ALC_WritePelBlock(XPel* pSrc, int SrcY, int SrcX, int SrcStride, int DstY, int DstX, int BlkH, int BlkW);
void ALC_ClearALCFrame();
void ALC_WriteALCFrame2File();

#endif //__ALC_LOGIC__