#include "ALC_Logic.h"

#ifdef _WIN32
#include <crtdbg.h>
#endif // _WIN32

#include <stdio.h>
#include <math.h>
#include "../inc/memalloc.h"

#if(DEBUG_PROCESSING)
#include "debug_processing.h"
#endif//(DEBUG_PROCESSING)

#define ALC_FIXED_REF_DEC_THRESHOLD (1)

// Internal variables
	
	const double SIGMA_ARRAY[NUMBER_OF_SIGMA] = {0.1, 0.3, 0.05};

#if(ALC_SPEED_OPT)
	char Template_visit[256];
  short  AlreadyProcessed[256];

#endif
	//static XYVL_STRUCT TemplateRef[MAX_TEMPLATE_VOLUME];
	//static XYVL_STRUCT TemplateDec[MAX_TEMPLATE_VOLUME];
	/*static*/ XPel TemplateRef[MAX_TEMPLATE_VOLUME];
	/*static*/ XPel TemplateDec[MAX_TEMPLATE_VOLUME];
    static int TemplateRef_minus_Dec[MAX_TEMPLATE_VOLUME];	 // saves Ref minus Dec
    static XPel TemplateRefDecOK[MAX_TEMPLATE_VOLUME];	     // if abs(ref - dec) < TH , than non zero;else - zero
#if(SMRC_ALC_ADAPT_16x16_TMPL)
	static int TemplateMRSAD[MAX_TEMPLATE_VOLUME>>4];
	static int MRSAD16x16;
	static TMPL_HIST_BIN TemplateHist16x16[256];
#endif
	/*static*/ TMPL_HIST_BIN TemplateHist[256];

//histogram in the form of separate arrays
  unsigned short TemplateHistAccRef[256];
  unsigned short TemplateHistAccDec[256];
  unsigned char TemplateHistVolume[256];

  // temp-temp1 < TH_REF_DEC ?
//  unsigned char DifSignificance[512];
//  unsigned char* pDifSignificance = DifSignificance + 255;
#if (USE_TRY_MARK_ALC)
  int TemplateTryMarkArray[256];
  int TemplateTryMark;
#endif
#if (LST_IMPL_OF_ACC)
//Oct'1 2012: Mike, for emulation of a lists
  unsigned short* pPointer2CellsAccRef[256];
  unsigned short* pPointer2CellsAccDec[256];
  // actually char is enough
  unsigned short TemplateHistVl[256];
  int TemlplateLST_Vol;
#endif

#if (0 == USE_SINGLE_MULTIPLIER)
int MULT_256[256*128];
int NonZeroHighestBit[257];
#endif

#if (1 == USE_SINGLE_MULTIPLIER || 2 == USE_SINGLE_MULTIPLIER || 1)
int ref_sum;
int dec_sum;
#endif
#if ALC_SIGNCHNECK_OUTLIER_REJECTION
    int acc_minus[256];
    int acc_plus[256];
    int acc_zero[256];
    int acc_plus_sub_minus[256];
    int acc_plus_add_minus[256];
    int abs_acc_plus_sub_minus[256];
#endif
  int acc;
	int acc_volume;
#if(SAVE_REF_MEAN_4_EACH_BIN || 0 == USE_APPROXIMATED_REF_ACC)
	int acc_ref;
#endif
	/*static*/ int RefTemplMin;
	/*static*/ int RefTemplMax;
    /*static*/ int SigmaNumber;
	static int pel_pred[MAX_TEMPLATE_VOLUME];
	/*static*/ int CurTemplateCapacity;
	static int CurTemplateCapacityRef;
	static int CurTemplateCapacityDec;
#if(FIXED_POINT)
	/*static*/ int** pExpTableLuma;
    int* pTemplExpTable;

#else
	/*static*/ double** pExpTableLuma;
    double* pTemplExpTable;
#endif
	static Boolean ALCTurnONFlag;

	//flag that is used for fixing fact of template filling
	static int TMIsFilled = 0;

	//arrays for horizontal and vertical sub-parts of template:
	/*
	Example: TM with size 2 around block 4x4

				HH HH HH HH HH
				HH HH HH HH HH
				VV
				VV
				VV
				VV

	*/
	static XPel** ppTM_horbuf;
	static XPel** ppTM_verbuf;
	static XPel** ppTM_buf;
	XPel* pTM_buf44;
	static int** ppTM_tempbuf;

#if( 0 != SMRC_SILENT_ALC_4_PSKIP)
	static XPel** pred_buf;
#endif

#if( SMRC_SILENT_ALC_4_PSKIP_WITHOUT_SIMILAR_TEMPLATES || SMRC_SILENT_ALC_4_PSKIP_WITHOUT_DISSIMILAR_TEMPLATES)
	static int enabled_alc_skip = 0;
	static int pred_direction_is_interview;
	static int res_mode_in_skip;
#endif

#if(SMRC_SILENT_ALC_4_PSKIP	== -1)
	FILE* pfStat;
	static int count_skip_mb;
#endif

/*
	Initialization

	Table with EXP(SIGMA)
*/
void PiLC_Create()
{
	int i, k;
#if(FIXED_POINT)
	pExpTableLuma = (int**)malloc( sizeof(int*) * NUMBER_OF_SIGMA);		
	for(k = 0; k < NUMBER_OF_SIGMA; ++k)
	{
#if (EXP_TABLE_HALF)
		pExpTableLuma[k] = (int*)malloc( sizeof(int) * 256);		
		for(i=0; i <256; ++i)
        {
#if(0 == WEIGHT_MODEL)
            if (abs(i) > REF_REF_LUMA_DIF_THRESHOLD)
			    pExpTableLuma[k][i] = 0;
            else
#if (FIXED_UNIT_WEIGHT)
                pExpTableLuma[k][i] = FIXED_POINT_PRESISION_MUL;
                //pExpTableLuma[k][i] = 1;
#else
			pExpTableLuma[k][i] = (int)floor(exp(-(i) * 0.5 * SIGMA_ARRAY[k]) * FIXED_POINT_PRESISION_MUL + 0.5);
#endif
#else
            double xp;
			double A,B,G;
			//TH = 16 ( PL = ~085)
			A = 0.05;
			B = 1.0;
			G = 0;
			xp = pow(i, B);			
            if (abs(i) > REF_REF_LUMA_DIF_THRESHOLD)
                pExpTableLuma[k][i] = 0;
            else
            pExpTableLuma[k][i] = (int)floor( exp(- A * xp + G ) * FIXED_POINT_PRESISION_MUL + 0.5);
#endif
        }
#else   //EXP_TABLE_HALF
    pExpTableLuma[k] = (int*)malloc( sizeof(int) * 512);		
		for(i=-255; i <=255; ++i)
        {
#if(0 == WEIGHT_MODEL)
            if (abs(i) > REF_REF_LUMA_DIF_THRESHOLD)
                pExpTableLuma[k][i + 255] = 0;
            else
#if (FIXED_UNIT_WEIGHT)
                //pExpTableLuma[k][i + 255] = FIXED_POINT_PRESISION_MUL;
                pExpTableLuma[k][i + 255] = 1;
#else
			    pExpTableLuma[k][i + 255] = (int)floor(exp(-(abs(i)) * 0.5 * SIGMA_ARRAY[k]) * FIXED_POINT_PRESISION_MUL + 0.5);
#endif
#else
            double xp;
			double A,B,G;
			//TH = 16 ( PL = ~085)
			A = 0.05;
			B = 1.0;
			G = 0;
			xp = pow(abs(i), B);			
            if (abs(i) > REF_REF_LUMA_DIF_THRESHOLD)
                pExpTableLuma[k][i + 255] = 0;
            else
                pExpTableLuma[k][i + 255] = (int)floor( exp(- A * xp + G ) * FIXED_POINT_PRESISION_MUL + 0.5);
#endif
        }
#endif  //EXP_TABLE_HALF
	}
#else
	pExpTableLuma = (double**)malloc( sizeof(double*) * NUMBER_OF_SIGMA);		
	for(k = 0; k < NUMBER_OF_SIGMA; ++k)
	{
		pExpTableLuma[k] = (double*)malloc( sizeof(double) * 256);		
		for(i=0; i <256; ++i)		
		{
#if(0 == WEIGHT_MODEL)
			pExpTableLuma[k][i] = exp(-(i) * 0.5 * SIGMA_ARRAY[k]);			
#else
			double xp;
			double A,B,G;
			//TH = 16 ( PL = ~085)
			A = 0.0054;
			B = 1.2092;
			G = -0.0064;
			xp = pow(i, B);
			pExpTableLuma[k][i] = exp(- A * xp + G );
#endif
		}
	}
#endif

	//ALCTurnONFlag = TRUE;
	ALCTurnONFlag = FALSE;

	// maximum memory allocation:
	get_mem2Dpel(&ppTM_horbuf, 16 + MAX_TEMPLATE_SIZE, 16 + MAX_TEMPLATE_SIZE);
	get_mem2Dpel(&ppTM_verbuf, 16 + MAX_TEMPLATE_SIZE, 16 + MAX_TEMPLATE_SIZE);

	get_mem2Dpel(&ppTM_buf, 16 + MAX_TEMPLATE_SIZE, 16 + MAX_TEMPLATE_SIZE);
	pTM_buf44 = &(ppTM_buf[MAX_TEMPLATE_SIZE][MAX_TEMPLATE_SIZE]);
	get_mem2Dint(&ppTM_tempbuf, 16 + MAX_TEMPLATE_SIZE + 5, 16 + MAX_TEMPLATE_SIZE + 5); //temporal buffer for in-place interpolation inside AVC. +5 is needed.
#if( 0 != SMRC_SILENT_ALC_4_PSKIP)
	get_mem2Dpel(&pred_buf, 16, 16);
#endif

#if(SMRC_SILENT_ALC_4_PSKIP	== -1)
	pfStat = fopen( "statALCSkip.log", "wt");
	count_skip_mb = 1;
#endif

#if (LST_IMPL_OF_ACC)
	//Additional initial clean 
	//memset(TemplateHistAccRef, 0, sizeof(unsigned short)*256);
	//memset(TemplateHistAccDec, 0, sizeof(unsigned short)*256);
	memset(TemplateHistVl,-1, sizeof(short)*256);
#if (USE_TRY_MARK_ALC)
  memset(TemplateTryMarkArray, 0, sizeof(int)* (256) );  
  TemplateTryMark = 0;
#endif
	TemlplateLST_Vol = 0;

	//clear template visit array
  	memset( &AlreadyProcessed, -1, sizeof(short)*256); 
#endif

#if (0==USE_SINGLE_MULTIPLIER)
  //1024 just to have a range
  for ( i=0; i < 1024; ++i)
  {
    if (i) 
      MULT_256[i] = (int)floor(0.5 + (1 << PRECISION_FOR_INT_DIVISION)*1.0/i);
    else
      MULT_256[i] = 0;
  }

  for ( i=0; i <= 256; ++i)
  {
    if (i & 0x100)
      NonZeroHighestBit[i] = 8;
    else
    if (i & 0x80)
      NonZeroHighestBit[i] = 7;
    else
    if (i & 0x40)
      NonZeroHighestBit[i] = 6;
    else
    if (i & 0x20)
      NonZeroHighestBit[i] = 5;
    else
    if (i & 0x10)
      NonZeroHighestBit[i] = 4;
    else
    if (i & 0x8)
      NonZeroHighestBit[i] = 3;
    else
    if (i & 0x4)
      NonZeroHighestBit[i] = 2;
    else
    if (i & 0x2)
      NonZeroHighestBit[i] = 1;
    else
    if (i & 0x1)
      NonZeroHighestBit[i] = 0;

    // in order to use directly in the code for shifting!
    if (NonZeroHighestBit[i] && i)
      ++NonZeroHighestBit[i];
  }  
#endif

  //is taken from TMInit()
    SigmaNumber = 0;
#if(EXP_TABLE_HALF)    
    pTemplExpTable = pExpTableLuma[SigmaN];
#else
    //to get pointer to the appropriate table     
    pTemplExpTable = pExpTableLuma[SigmaNumber];
    pTemplExpTable  = pTemplExpTable + 255;  // to shift 0 position to the 255 position
#endif

/*
    for(i =0; i < 511; ++i)
    {
      if ( iabs(i - 255) <= REF_DEC_LUMA_DIF_THRESHOLD )
        DifSignificance[i] = 1;
      else
        DifSignificance[i] = 0;
    }
*/
}
/*
	Deinitialization of PiLC
*/
void PiLC_Destroy()
{
	int k;
#if(SMRC_SILENT_ALC_4_PSKIP	== -1)
	fclose(pfStat);
#endif
	for(k = 0; k < NUMBER_OF_SIGMA; ++k)	
		free(pExpTableLuma[k]);
	free(pExpTableLuma);

	free_mem2Dpel(ppTM_horbuf);
	free_mem2Dpel(ppTM_verbuf);
	free_mem2Dpel(ppTM_buf);
	free_mem2Dint(ppTM_tempbuf);
#if( 0 != SMRC_SILENT_ALC_4_PSKIP)
	free_mem2Dpel(pred_buf);
#endif

}

XPel PiLC_MxCalc(	XPel* pSrc,
					int YSrc, int XSrc,
					int BlockH, int BlockW,
					int WidthSrc,
					int stepSrc_x, int stepSrc_y)
{	
	int i, j;
	int offset_ySrc = stepSrc_y * WidthSrc;	
	int x_src, y_src;
	int mx_src;		
	int BlockSq;

	mx_src = 0;				
	BlockSq = BlockH * BlockW;		
	for(i = 0, y_src = YSrc * WidthSrc; i < BlockH; ++i, y_src += offset_ySrc)
	for(j = 0, x_src = XSrc; j < BlockW; ++j, x_src +=stepSrc_x)
	{
		mx_src += pSrc[y_src + x_src];
	}

	mx_src /= BlockSq;
	return (XPel)mx_src;
}

int PiLC_GetTMCapacity(void)
{
	if (CurTemplateCapacityDec != CurTemplateCapacityRef)
	{
		printf("PiLC_Template_MakeAveragedHist: Templates capacity for reference and decoded are not equal!\n");
		return -1;
	}
	else		
		return CurTemplateCapacityRef;
}

/*
	Collects histogram over reference template.
	For each certain value TemplateRef[i].vl existed in reference template array, all corresponding values from decoded template are accumulated.

	Histogram provides the following info:
	- Min/Max value of reference template
	- TemplateHist[i].acc - sum of all pixel-values from decoded template that sptially correspond to reference -template pixels that are equal i
	- TemplateHist[i].acc_volume number of pixel-values accumulated in TemplateHist[i].acc.
*/

/*
	Collects histogram over reference template.
	For each certain value TemplateRef[i].vl existed in reference template array, all corresponding values from decoded template are accumulated.

	Histogram provides the following info:
	- Min/Max value of reference template
	- TemplateHist[i].acc - sum of all pixel-values from decoded template that sptially correspond to reference -template pixels that are equal i
	- TemplateHist[i].acc_volume number of pixel-values accumulated in TemplateHist[i].acc.
*/
void PiLC_TMMakeAveragedHistogram()
{
	int i, j, count,vl, i1;
    int ref_dec_th;
    int ref_dec_delta_mean;
    int ref_dec_delta_std;
    int temp;
	if (CurTemplateCapacityDec != CurTemplateCapacityRef)
	{
		printf("PiLC_Template_MakeAveragedHist: Templates capacity for reference and decoded are not equal!\n");
		return;
	}
	if (CurTemplateCapacityDec != CurTemplateCapacity)
	{
		printf("PiLC_Template_MakeAveragedHist: CurTemplateCapacityDec != CurTemplateCapacity!\n");
		return;
	}

	if (0 == CurTemplateCapacity)
	{
		printf("PiLC_Template_MakeAveragedHist: Templates are empty!\n");
		return;
	}

	//clear hist accumulators
/*
	for(int i=0; i < 256; ++i)
	{
		TemplateHist[i].acc = 0;
		TemplateHist[i].acc_volume = 0;		
	}
*/
//	memset(TemplateHist, 0, sizeof(TMPL_HIST_BIN)* 256);

	RefTemplMin = 256;
	RefTemplMax = -1;

#if (ALC_FIXED_REF_DEC_THRESHOLD)
    ref_dec_th = REF_DEC_LUMA_DIF_THRESHOLD;
#else
    ref_dec_delta_mean = 0;
    ref_dec_delta_std = 0;

    
//    printf("ref_dec_delta_std: %d\n", ref_dec_delta_std);

    for(j = 0; j < REF_DEC_LUMA_DIF_THRESHOLD; ++j)
    {
        count = 0;
        for(i = 0; i < CurTemplateCapacity; ++i)
            if ( abs((int)(TemplateRef[i].vl) - (int)(TemplateDec[i].vl)) < j)
                ++count;

        if (count >= CurTemplateCapacity * 0.95)
            break;
    }
    ref_dec_th = j;

#endif

//Calculation of global min/max over template and initial settings:
    for(i = 0; i < CurTemplateCapacity; ++i)
	{
        TemplateRefDecOK[i] = 0;
        TemplateRef_minus_Dec[i] = (int)(TemplateRef[i]) - (int)(TemplateDec[i]);
		if ( abs( TemplateRef_minus_Dec[i] ) <= ref_dec_th )
		{
            TemplateRefDecOK[i] = 1;
			i1 = TemplateRef[i] >> AVERAGED_FACTOR_SH;	

			if (RefTemplMin > i1)
				RefTemplMin = i1;
			if (RefTemplMax < i1)
				RefTemplMax = i1;
		}
	}

    if( RefTemplMin == 256 && RefTemplMax==-1)
        return; // no available elements that satisfy thresholds conditions
    // Clear only necceessary elements
	memset((TemplateHist + RefTemplMin), 0, sizeof(TMPL_HIST_BIN)* (RefTemplMax - RefTemplMin + 1));


#if ALC_SIGNCHNECK_OUTLIER_REJECTION
	//collect histogram and make averaging:
	for(i = 0; i < CurTemplateCapacity; ++i)
	{
		if ( TemplateRefDecOK[i] )
		{
			i1 = TemplateRef[i] >> AVERAGED_FACTOR_SH;

			if (TemplateRef_minus_Dec[i] >= ALC_SIGNCHNECK_OUTLIER_REJECTION_ELEM_REF_DEC_TH)
				++TemplateHist[ i1 ].acc_plus;
			else
            if (TemplateRef_minus_Dec[i] <= -ALC_SIGNCHNECK_OUTLIER_REJECTION_ELEM_REF_DEC_TH)
				++TemplateHist[ i1 ].acc_minus;
			else
				++TemplateHist[ i1 ].acc_zero;
		}
	}

     for(i = RefTemplMin; i <=RefTemplMax; ++i)
     {
         // 2012'July'17: Mike: there is an error related with index! not i1 but i !!!
         TemplateHist[ i ].acc_plus_sub_minus = TemplateHist[ i ].acc_plus - TemplateHist[ i/*i1*/ ].acc_minus;
         TemplateHist[ i ].abs_acc_plus_sub_minus = abs(TemplateHist[ i ].acc_plus_sub_minus);
     }
    
#endif

	//collect histogram and make averaging:
	for(i = 0; i < CurTemplateCapacity; ++i)
	{
		if ( TemplateRefDecOK[i] )
		{
#if(AVERAGED_FACTOR_SH)
			i1 = TemplateRef[i] >> AVERAGED_FACTOR_SH;
#else
            i1 = TemplateRef[i];
#endif

#if ALC_SIGNCHNECK_OUTLIER_REJECTION
/*
			if ( (( TemplateHist[ i1 ].acc_plus > (TemplateHist[ i1 ].acc_minus)) && (TemplateRef[i] > TemplateDec[i] )) ||
					 (( (TemplateHist[ i1 ].acc_plus) < TemplateHist[ i1 ].acc_minus ) && (TemplateRef[i] < TemplateDec[i] ))
				 )

*/
            if (
                    //(   TemplateHist[ i1 ].abs_acc_plus_sub_minus < ALC_SIGNCHNECK_OUTLIER_REJECTION_TH && abs(TemplateRef_minus_Dec[i]) < ALC_SIGNCHNECK_OUTLIER_REJECTION_ELEM_REF_DEC_TH) ||
                    (   TemplateHist[ i1 ].abs_acc_plus_sub_minus < ALC_SIGNCHNECK_OUTLIER_REJECTION_TH ) ||
                    (   TemplateHist[ i1 ].acc_plus_sub_minus >= ALC_SIGNCHNECK_OUTLIER_REJECTION_TH  && TemplateRef_minus_Dec[i] >= ALC_SIGNCHNECK_OUTLIER_REJECTION_ELEM_REF_DEC_TH ) ||
                    (   TemplateHist[ i1 ].acc_plus_sub_minus <= -ALC_SIGNCHNECK_OUTLIER_REJECTION_TH && TemplateRef_minus_Dec[i] <= -ALC_SIGNCHNECK_OUTLIER_REJECTION_ELEM_REF_DEC_TH )

//                    (   TemplateHist[ i1 ].acc_plus_sub_minus > 0 && TemplateRef[i] > (TemplateDec[i] + ALC_SIGNCHNECK_OUTLIER_REJECTION_ELEM_REF_DEC_TH) && TemplateHist[ i1 ].abs_acc_plus_sub_minus >=ALC_SIGNCHNECK_OUTLIER_REJECTION_TH) ||
//                    (   TemplateHist[ i1 ].acc_plus_sub_minus < 0 && TemplateDec[i] > (TemplateRef[i] + ALC_SIGNCHNECK_OUTLIER_REJECTION_ELEM_REF_DEC_TH) && TemplateHist[ i1 ].abs_acc_plus_sub_minus >=ALC_SIGNCHNECK_OUTLIER_REJECTION_TH) 
                )
               
#endif
		{
				TemplateHist[ i1 ].acc += TemplateDec[i];
			#if(SAVE_REF_MEAN_4_EACH_BIN)
					TemplateHist[ i1 ].acc_ref += TemplateRef[i];
			#endif

			    ++TemplateHist[ i1 ].acc_volume;

            #if(!USE_APPROXIMATED_REF_ACC)			               
                TemplateHist[ i1 ].acc_ref += TemplateRef[i];
            #endif
		}
	}
	}

}

void PiLC_TMInit()
{
	int i;
	//clear template visit array
//  	memset( &AlreadyProcessed, -1, sizeof(short)*256); 
	CurTemplateCapacity = 0;
	CurTemplateCapacityRef = 0;
	CurTemplateCapacityDec = 0;
	TMIsFilled = TM_EMPTY;
}


int PiLC_TMCreateAtom(	XPel **ppFrame, int IsReferenceTemplate,
						int block_y, int block_x,
						int block_h, int block_w,
						int Height, int Width
					)
{	
	XYVL_STRUCT* pTemplate;
	int i, j;
	int i1, j1;
	int idx;
	if ( (block_y < 0) || (block_y + block_h) > Height || (block_x < 0) || (block_x + block_w) > Width)
	{
		//printf("\nAAAAAA\n");
		return ALCERR;
	}
	if(IsReferenceTemplate)
	{
		pTemplate = TemplateRef;
		idx = CurTemplateCapacityRef;	
	}
	else
	{
		pTemplate = TemplateDec;
		idx = CurTemplateCapacityDec;	
	}

	if (idx > MAX_TEMPLATE_VOLUME)
	{
		printf("PiLC_TMCreateAtom: CurTemplateCapacity >= MAX_TEMPLATE_VOLUME!\n");
		return ALCERR;
	}
	
/*	for(i1 = 0; i1 < block_h; i1+=4)
	{
		for(j1 = 0; j1 < block_w; j1+=4)
		{
			for(i=i1; i < i1+4; ++i)
			{
				for(j=j1; j < j1+4; ++j)
				{
*/
    for(i1 = 0; i1 < block_h; i1 += MAX_TEMPLATE_SIZE)
	{
		for(j1 = 0; j1 < block_w; j1 += MAX_TEMPLATE_SIZE)
		{
			for(i=i1; i < i1+MAX_TEMPLATE_SIZE; ++i)
			{
				for(j=j1; j < j1+MAX_TEMPLATE_SIZE; ++j)
				{

    
					//pTemplate[idx].x  = block_x + j;
					//pTemplate[idx].y  = block_y + i;
					pTemplate[idx].vl = ppFrame[ block_y + i ][ block_x + j ];
					++idx;
				}
				//memcpy( &(pTemplate[idx].vl), &(ppFrame[ block_y + i ][ block_x + j1 ]), 4*sizeof(XPel));
				//idx += 4;
			}
			//memcpy( pTemplate + idx+ 0, &(ppFrame[ block_y + i1 +0][ block_x + j1 ]), 4*sizeof(XPel));
			//memcpy( pTemplate + idx+ 4, &(ppFrame[ block_y + i1 +1][ block_x + j1 ]), 4*sizeof(XPel));
			//memcpy( pTemplate + idx+ 8, &(ppFrame[ block_y + i1 +2][ block_x + j1 ]), 4*sizeof(XPel));
			//memcpy( pTemplate + idx+12, &(ppFrame[ block_y + i1 +3][ block_x + j1 ]), 4*sizeof(XPel));
			//idx += 16;
		}
	}
	
	/*for(i = 0; i < block_h; i++)
	{
		for(j = 0; j < block_w; j++)
		{
					pTemplate[idx].x  = block_x + j;
					pTemplate[idx].y  = block_y + i;
					pTemplate[idx].vl = ppFrame[ pTemplate[idx].y ][ pTemplate[idx].x ];
					++idx;
		}
	}*/

	if(IsReferenceTemplate)	
		CurTemplateCapacityRef = idx;	
	else
		CurTemplateCapacityDec = idx;	

	if (idx > MAX_TEMPLATE_VOLUME)
	{
		printf("PiLC_TMCreateAtom: CurTemplateCapacity >= MAX_TEMPLATE_VOLUME!\n");
		return ALCERR;
	}
#ifdef _WIN32
	_ASSERTE(idx <= MAX_TEMPLATE_VOLUME);
#endif // _WIN32
	return ALCOK;	
}

/*
	Filling of a template buffer block-by-block: either reference or decoded one
*/
int PiLC_TMFill(	XPel **ppFrame, int IsReferenceTemplate,
					int block_y, int block_x,
					int block_h, int block_w,
					int Height, int Width,
					int template_thickness
				)
{
	int number_of_success_template_parts = 0;

	//get Vertical template 
	if (ALCOK == PiLC_TMCreateAtom(	ppFrame, IsReferenceTemplate, 
									block_y, block_x - template_thickness, block_h, template_thickness, 
									Height, Width))
		++number_of_success_template_parts;


#if(SMRC_ALC_FULL_TMPL)
	//get Horizontal template
	if (ALCOK == PiLC_TMCreateAtom(	ppFrame, IsReferenceTemplate, 
									block_y - template_thickness, block_x - template_thickness, template_thickness, block_w + template_thickness, 
									Height, Width))
		++number_of_success_template_parts;
#else
	//get Horizontal template
	if (ALCOK == PiLC_TMCreateAtom(	ppFrame, IsReferenceTemplate, 
									block_y - template_thickness, block_x, template_thickness, block_w, 
									Height, Width))
		++number_of_success_template_parts;
#endif

/*
	//get Horizontal/vertical template
	if (m_Template_CreateAtom(	pFrame, IsReferenceTemplate, 
								block_y - template_thickness * YScale, block_x - template_thickness * XScale, template_thickness, template_thickness, 
								YScale, XScale, Height, Width))
		++number_of_success_template_parts;
*/
	if (2 == number_of_success_template_parts)	
		return ALCOK;
	else
		return ALCERR_TMFILL;
		
}

/*
	This function takes pixels from reference and decoded template areas in respect of pixel positions of left-top corners:
	- RefTM_startY, RefTM_startX : left-top corner of a block nearby whom template can be taken
	- DecTM_startY, DecTM_startX : left-top corner of a block nearby whom template can be taken

	Blk_height - total height of the block inside a template
	Blk_width - total width of the block inside a template

	return 0 if procedure was succeed.
	Non-zero value in case of any error.

	Descriptions of error values:

*/
#if(1 == ALC_OPT1)
int ALC_GetTM(	XPel **ppRef, int RefTM_startY, int RefTM_startX, 
				XPel **ppDec, int DecTM_startY, int DecTM_startX, 
				int Blk_height, int Blk_width, int TM_size,
				int FrameH, int FrameW)
{
  XPel temp, temp1;
	int idx,i1,j1;
  int i, j;
  int stride_ref, stride_dec;
	XPel** ppCurRef;
	XPel** ppCurDec;

	XPel* pCurRefTemp;
	XPel* pCurDecTemp;

//  XPel** ppCurRefTemp;
//	XPel** ppCurDecTemp;

  XPel* TemplateRefTemp;
  XPel* TemplateDecTemp;
  int* TemplateRef_minus_DecTemp;

/*
#if( SMRC_SILENT_ALC_4_PSKIP_WITHOUT_SIMILAR_TEMPLATES || SMRC_SILENT_ALC_4_PSKIP_WITHOUT_DISSIMILAR_TEMPLATES)
		res_mode_in_skip = 0;
#endif
*/
	//if (((Blk_height  + Blk_width) *  TM_size + TM_size * TM_size) > MAX_TEMPLATE_VOLUME)
	//	return ALCERR_VOLUME;

	//init template storage
	PiLC_TMInit();


#if(!ALC_SPEED_OPT)
	//Getting of a reference template
	if (ALCOK != PiLC_TMFill(	ppRef, 1,
								RefTM_startY, RefTM_startX,
								Blk_height, Blk_width,
								FrameH, FrameW, TM_size))
	{
		TMIsFilled = TM_EMPTY;
		return ALCERR_TMFILL_REF;
	}

	//Getting of a decoded template	
	if (ALCOK != PiLC_TMFill(	ppDec, 0,
								DecTM_startY, DecTM_startX,
								Blk_height, Blk_width,
								FrameH, FrameW, TM_size))
	{
		TMIsFilled = TM_EMPTY;
		return ALCERR_TMFILL_DEC;
	}

	if( CurTemplateCapacityRef != CurTemplateCapacityDec)
	{
			printf("ALC_GetTM: CurTemplateCapacityRef != CurTemplateCapacityDec!\n");
			TMIsFilled = TM_FILLED;
			return ALCERR;
	}
	else	
		CurTemplateCapacity = CurTemplateCapacityRef;

#else//(!ALC_SPEED_OPT)

	// upper block of the template
	ppCurRef = &ppRef[ RefTM_startY];
	ppCurDec = &ppDec[ DecTM_startY];
	idx = 0;
  RefTemplMin = 256;
	RefTemplMax = -1;
  TemplateRefDecOK[idx] = 0;

/*//////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
"optimal" memory read/write operations, w/o too much overhead
///////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////*/

  TemplateRefTemp = TemplateRef;
  TemplateDecTemp = TemplateDec;
  TemplateRef_minus_DecTemp = TemplateRef_minus_Dec;
 // upper block of the template
  for(i1 = -TM_size; i1 < 0; ++i1)      
  {    
    pCurRefTemp = ppCurRef[ i1 ] + RefTM_startX;
    pCurDecTemp = ppCurDec[ i1 ] + DecTM_startX;

#if(0)
    //this is how it was before opt
    memcpy(TemplateRefTemp, pCurRefTemp, sizeof(XPel) * Blk_width);
    memcpy(TemplateDecTemp, pCurDecTemp, sizeof(XPel) * Blk_width);
    TemplateRefTemp += Blk_width;
    TemplateDecTemp += Blk_width;
#endif

    //BD
    for(j1 = 0; j1 < Blk_width; ++j1)
    {            
      //if ( iabs(pCurRefTemp[j1] - pCurDecTemp[j1]) <= REF_DEC_LUMA_DIF_THRESHOLD )
      temp = pCurRefTemp[j1];
      temp1 = pCurDecTemp[j1];      
      if ( iabs(temp - temp1) <= REF_DEC_LUMA_DIF_THRESHOLD )
      {        
#if (ALC_SIGNCHNECK_OUTLIER_REJECTION)
        *TemplateRef_minus_DecTemp = temp - temp1;
        ++TemplateRef_minus_DecTemp;
#endif;
        *TemplateRefTemp = temp;
        *TemplateDecTemp = temp1;
//        TemplateRefDecOK[idx] = 1;
//        ++idx;
//        TemplateRefDecOK[idx] = 0; // clear next position

#if(AVERAGED_FACTOR_SH)
        temp = temp >> AVERAGED_FACTOR_SH;	
#endif
        if (temp > RefTemplMax)
            RefTemplMax = temp;
        if (temp < RefTemplMin)
            RefTemplMin = temp;

        ++TemplateRefTemp;
        ++TemplateDecTemp;
      }
    }
  }

  RefTM_startX -=TM_size;
  DecTM_startX -= TM_size;

  //get strides:
  stride_ref = &(ppCurRef[1][0]) - &(ppCurRef[0][0]);
  stride_dec = &(ppCurDec[1][0]) - &(ppCurDec[0][0]);
// left block of the template  
  for(j1 = -TM_size; j1 < 0; ++j1)
  {    

    // get pointers to the X start positions:
    pCurRefTemp = &(ppCurRef[0][RefTM_startX]);
    pCurDecTemp = &(ppCurDec[0][DecTM_startX]);

    for(i1 = 0; i1 < Blk_height; ++i1)
    {
#if(0)
    //this is how it was before opt
      *(TemplateRefTemp++) = ppCurRef[i1][RefTM_startX];
      *(TemplateDecTemp++) = ppCurDec[i1][DecTM_startX];   
#endif
      //BD
//      *(TemplateRefTemp++) = 1;
//      *(TemplateDecTemp++) = 1;
//      ++idx;

//      if ( iabs(ppCurRef[i1][RefTM_startX] - ppCurDec[i1][DecTM_startX]) <= REF_DEC_LUMA_DIF_THRESHOLD )
//      if ( iabs(*pCurRefTemp - *pCurDecTemp) <= REF_DEC_LUMA_DIF_THRESHOLD )
      temp = *pCurRefTemp;
      temp1 = *pCurDecTemp;
      if ( iabs(temp - temp1) <= REF_DEC_LUMA_DIF_THRESHOLD )
      {
//        temp = *TemplateRefTemp = ppCurRef[i1][RefTM_startX];
//               *TemplateDecTemp = ppCurDec[i1][DecTM_startX];
//        temp = *TemplateRefTemp = *pCurRefTemp;
//               *TemplateDecTemp = *pCurDecTemp;
#if (ALC_SIGNCHNECK_OUTLIER_REJECTION)
        *TemplateRef_minus_DecTemp = temp - temp1;
        ++TemplateRef_minus_DecTemp;
#endif;
          *TemplateRefTemp = temp;
          *TemplateDecTemp = temp1;
//        ++idx;
#if(AVERAGED_FACTOR_SH)
        temp = temp >> AVERAGED_FACTOR_SH;	
#endif
        if (temp > RefTemplMax)
            RefTemplMax = temp;
        if (temp < RefTemplMin)
            RefTemplMin = temp;

        ++TemplateRefTemp;
        ++TemplateDecTemp;
      }

      //move to the next line:
      pCurRefTemp += stride_ref;
      pCurDecTemp += stride_dec;
    }
    ++RefTM_startX;
    ++DecTM_startX;
  }  
  //CurTemplateCapacity = CurTemplateCapacityRef = CurTemplateCapacityDec = idx;
  CurTemplateCapacity = CurTemplateCapacityRef = CurTemplateCapacityDec = TemplateRefTemp - TemplateRef;
  
#if(0)
    //this is how it was before opt
  CurTemplateCapacity = CurTemplateCapacityRef = CurTemplateCapacityDec = TM_size * (Blk_height + Blk_width);
#endif
#endif//(!ALC_SPEED_OPT)

	//collect histogram. Tobe Optimized!
	PiLC_TMMakeAveragedHistogram();

//	TMIsFilled = TM_FILLED;

	ALC_TurnON();

	return ALCOK;
}

#if(SMRC_3DV && SMRC_ALC_AFTER_WP)
int ALC_after_WP(	XPel **ppRef, int RefTM_startY, int RefTM_startX, 
				XPel **ppDec, int DecTM_startY, int DecTM_startX, 
				int Blk_height, int Blk_width, int TM_size,
				int FrameH, int FrameW,int max_imgpel_value,
				short wp, short offset, short wp_round, short weight_denom, imgpel** mb_pred, int block_x)
{
	int idx,i1,j1;
	XPel** ppCurRef;
	XPel** ppCurDec;
#if( SMRC_SILENT_ALC_4_PSKIP_WITHOUT_SIMILAR_TEMPLATES || SMRC_SILENT_ALC_4_PSKIP_WITHOUT_DISSIMILAR_TEMPLATES)
		res_mode_in_skip = 0;
#endif

	//init template storage
	PiLC_TMInit();

	// upper block of the template
	ppCurRef = &ppRef[ RefTM_startY];
	ppCurDec = &ppDec[ DecTM_startY];
	idx = 0;
	for(i1 = -TM_size; i1 < 0; i1+=4)
	{
		for(j1 = 0; j1 < Blk_width; j1+=4)
		{
			memcpy( TemplateRef + idx+ 0, ppCurRef[ i1 +0]+ RefTM_startX + j1 , 4*sizeof(XPel));
			memcpy( TemplateRef + idx+ 4, ppCurRef[ i1 +1]+ RefTM_startX + j1 , 4*sizeof(XPel));
			memcpy( TemplateRef + idx+ 8, ppCurRef[ i1 +2]+ RefTM_startX + j1 , 4*sizeof(XPel));
			memcpy( TemplateRef + idx+12, ppCurRef[ i1 +3]+ RefTM_startX + j1 , 4*sizeof(XPel));
																										
			memcpy( TemplateDec + idx+ 0, ppCurDec[ i1 +0]+ DecTM_startX + j1 , 4*sizeof(XPel));
			memcpy( TemplateDec + idx+ 4, ppCurDec[ i1 +1]+ DecTM_startX + j1 , 4*sizeof(XPel));
			memcpy( TemplateDec + idx+ 8, ppCurDec[ i1 +2]+ DecTM_startX + j1 , 4*sizeof(XPel));
			memcpy( TemplateDec + idx+12, ppCurDec[ i1 +3]+ DecTM_startX + j1 , 4*sizeof(XPel));
			idx += 16;
		}
	}

	// left block of the template
	//ppCurRef = &ppRef[ RefTM_startY];
	//ppCurDec = &ppDec[ DecTM_startY];
	for(i1 = 0; i1 < Blk_height; i1+=4)
	{
		for(j1 = -TM_size; j1 < 0; j1+=4)
		{
			memcpy( TemplateRef + idx+ 0, ppCurRef[ i1 +0]+ RefTM_startX + j1 , 4*sizeof(XPel));
			memcpy( TemplateRef + idx+ 4, ppCurRef[ i1 +1]+ RefTM_startX + j1 , 4*sizeof(XPel));
			memcpy( TemplateRef + idx+ 8, ppCurRef[ i1 +2]+ RefTM_startX + j1 , 4*sizeof(XPel));
			memcpy( TemplateRef + idx+12, ppCurRef[ i1 +3]+ RefTM_startX + j1 , 4*sizeof(XPel));
																							
			memcpy( TemplateDec + idx+ 0, ppCurDec[ i1 +0]+ DecTM_startX + j1 , 4*sizeof(XPel));
			memcpy( TemplateDec + idx+ 4, ppCurDec[ i1 +1]+ DecTM_startX + j1 , 4*sizeof(XPel));
			memcpy( TemplateDec + idx+ 8, ppCurDec[ i1 +2]+ DecTM_startX + j1 , 4*sizeof(XPel));
			memcpy( TemplateDec + idx+12, ppCurDec[ i1 +3]+ DecTM_startX + j1 , 4*sizeof(XPel));
			idx += 16;
		}
	}

	CurTemplateCapacity = CurTemplateCapacityRef = CurTemplateCapacityDec = idx;

	for( i1 = 0; i1 < CurTemplateCapacity; i1++)
		 TemplateRef[i1] = (imgpel) iClip1( max_imgpel_value, ((wp *  TemplateRef[i1]  + wp_round) >> weight_denom) + offset);

	//collect histogram. Tobe Optimized!
	PiLC_TMMakeAveragedHistogram();

	TMIsFilled = TM_FILLED;

	ALC_TurnON();

	for(i1 = 0; i1 < Blk_height; i1++)
	{
		for(j1 = 0; j1 < Blk_width; j1++)
		{
			int Ref_Ref = 0;
			int Ref_Dec = 0;
			int Wk = 0;
			int delta,i,rec_vl;
			TMPL_HIST_BIN *ptempHist_bin;
			XPel ReferenceVl = (imgpel) iClip1( max_imgpel_value, ((wp *  *(ppCurRef[i1]+ RefTM_startX + j1)  + wp_round) >> weight_denom) + offset);

		// early termination in case of ReferenceVl was corrected in early stage.
			if(Template_visit[ReferenceVl] != -1)
			{
				mb_pred[i1][j1 + block_x] = Template_visit[ReferenceVl];
				continue;
			}

			//cycle over all the range of histogram:
			for(i=RefTemplMin; i <= RefTemplMax; ++i)
			{
				int i_rec  = i;
				if (TemplateHist[i].acc_volume)
				{
					delta = (ReferenceVl - i_rec);
					Wk = pTemplExpTable[delta];
					if (0 == Wk) 
						continue;
					Ref_Ref += TemplateHist[i].acc_ref * Wk;
					Ref_Dec += TemplateHist[i].acc * Wk;
				}
			}
			Ref_Dec >>= FIXED_POINT_INTER_SHIFT;
			Ref_Ref >>= FIXED_POINT_INTER_SHIFT;

			if (Ref_Ref)
				rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref>>1)) / Ref_Ref);
			else
				rec_vl = (int)ReferenceVl;

			if (rec_vl > 255)
				rec_vl = 255;
			mb_pred[i1][j1 + block_x] = Template_visit[ReferenceVl] = rec_vl;
		}
	}

	return ALCOK;
}
#endif
#elif(2 == ALC_OPT1)
int ALC_GetTM(	XPel **ppRef, int RefTM_startY, int RefTM_startX, 
				XPel **ppDec, int DecTM_startY, int DecTM_startX, 
				int Blk_height, int Blk_width, int TM_size,
				int FrameH, int FrameW)
{  
	int idx,i1,j1;
//  int i, j;
  int stride_ref, stride_dec;
	XPel** ppCurRef;
	XPel** ppCurDec;

	XPel* pCurRefTemp;
	XPel* pCurDecTemp;

  XPel* TemplateRefTemp;
  XPel* TemplateDecTemp;
  XPel* pCurRefTemp_line;
  XPel* pCurDecTemp_line;
 
  short temp, temp1, temp2;
  // for calculating abs below ( see iabs for details)  
  short x, y, z;
  static const short INT_BITS = (sizeof(short) * CHAR_BIT) - 1;
  
#if (0 == USE_SINGLE_MULTIPLIER)
	PiLC_TMInit();
#else
	CurTemplateCapacity = 0;
	CurTemplateCapacityRef = 0;
	CurTemplateCapacityDec = 0;
	TMIsFilled = TM_EMPTY;
#endif

	// upper block of the template
	ppCurRef = &ppRef[ RefTM_startY];
	ppCurDec = &ppDec[ DecTM_startY];
	idx = 0;
#if (0 == LST_IMPL_OF_ACC)
  RefTemplMin = 256;
	RefTemplMax = -1;
#endif

  /*//////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
"optimal" memory read/write operations, w/o too much overhead
///////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////*/ 
#if (0 == USE_SINGLE_MULTIPLIER)
  //init
#if (0 == LST_IMPL_OF_ACC)
  memset(TemplateHistAccRef, 0, sizeof(unsigned short)* (256>>AVERAGED_FACTOR_SH));
  memset(TemplateHistAccDec, 0, sizeof(unsigned short)* (256>>AVERAGED_FACTOR_SH));
  memset(TemplateHistVolume, 0, sizeof(unsigned char)* (256>>AVERAGED_FACTOR_SH) );  
#else
#if (0 == USE_TRY_MARK_ALC)
  memset(TemplateHistVolume, 0, sizeof(unsigned char)* (256>>AVERAGED_FACTOR_SH) );  
#endif
//  ref_sum = dec_sum = 0;
	#endif
#elif (1 == USE_SINGLE_MULTIPLIER || 2 == USE_SINGLE_MULTIPLIER)
  ref_sum = dec_sum = 1;
//  ref_sum = dec_sum = 0;
#endif
  // oct'1: index within "list"of acc cells
#if (LST_IMPL_OF_ACC)
  TemlplateLST_Vol= 0;
#if (USE_TRY_MARK_ALC)
  ++TemplateTryMark;
#endif
#endif

  stride_ref = ppCurRef[ -TM_size + 1] - ppCurRef[ -TM_size] - Blk_width;
  stride_dec = ppCurDec[ -TM_size + 1 ] - ppCurDec[ -TM_size ] - Blk_width;

  pCurRefTemp = ppCurRef[ -TM_size ] + RefTM_startX;
  pCurDecTemp = ppCurDec[ -TM_size ] + DecTM_startX;

 // upper block of the template
  for(i1 = -TM_size; i1 < 0; ++i1)      
  { 
//    pCurRefTemp = ppCurRef[ i1 ] + RefTM_startX;
    //pCurDecTemp = ppCurDec[ i1 ] + DecTM_startX;

    //BD
    for(j1 = 0; j1 < Blk_width; ++j1)
    {            
      //take values
      temp2 = temp = *pCurRefTemp++;
      temp1 = *pCurDecTemp++;      
#if ( REF_DEC_LUMA_DIF_THRESHOLD < 256)  // in this way we can turn-off ref_dec thresholding
      //if ( iabs(temp - temp1) <= REF_DEC_LUMA_DIF_THRESHOLD )
      x = (temp - temp1);
      y = x >> INT_BITS;
      z = (x ^ y) - y;
      if ( z <= REF_DEC_LUMA_DIF_THRESHOLD )
/*
      x = (temp + 8) >> 4;
      y = (temp1 + 8) >> 4;
      if (x==y)
*/
#endif
      {
#if (0 == USE_SINGLE_MULTIPLIER)
#if(AVERAGED_FACTOR_SH)
        temp = temp >> AVERAGED_FACTOR_SH;	
#endif

#if (USE_TRY_MARK_ALC)
        if( TemplateTryMark !=TemplateTryMarkArray[temp] )
#else
        if (0 == TemplateHistVolume[temp])
#endif
        {
#if (0 == LST_IMPL_OF_ACC)
          // check only if was not checked before?
          if (temp > RefTemplMax)
              RefTemplMax = temp;
          if (temp < RefTemplMin)
              RefTemplMin = temp;
#endif
          //initialization of arrays. In order to exclude memset for the whole array
//          TemplateHistAccRef[temp] = TemplateHistAccDec[temp] = 0;
          // its commented in order to aviod extra if in the correction cycle because otherwise we should chech whether array was initialized or not.
#if (LST_IMPL_OF_ACC)
					// let store pointers for corresponding cells of accumulators 
					pPointer2CellsAccRef[temp] = &TemplateHistAccRef[TemlplateLST_Vol];
					pPointer2CellsAccDec[temp] = &TemplateHistAccDec[TemlplateLST_Vol];
					*(pPointer2CellsAccRef[temp]) = (XPel)temp2;
					*(pPointer2CellsAccDec[temp]) = (XPel)temp1;
					//we also need to save value of reference template pixel in order to calculate weight afterwords
					TemplateHistVl[TemlplateLST_Vol++] = temp;
#endif
#if (USE_TRY_MARK_ALC)
          TemplateTryMarkArray[temp] = TemplateTryMark;
#else
          TemplateHistVolume[temp] = 1;
#endif

        }
#if (0 != LST_IMPL_OF_ACC)
				else
				{
					*(pPointer2CellsAccRef[temp]) +=(XPel)temp2;
					*(pPointer2CellsAccDec[temp]) +=(XPel)temp1;
        }

//        ref_sum += temp2;
//        dec_sum += temp1;
#else
        //filing histogram arrays
        TemplateHistAccRef[temp] += (XPel)temp2;
        TemplateHistAccDec[temp] += (XPel)temp1;
#endif
        ++idx;

#elif (1 == USE_SINGLE_MULTIPLIER || 2 == USE_SINGLE_MULTIPLIER )
        ref_sum += temp2;
        dec_sum += temp1;
#endif
      }
    }
    pCurRefTemp += stride_ref;
    pCurDecTemp += stride_dec;
  }

// left block of the template
  RefTM_startX -=TM_size;
  DecTM_startX -= TM_size;


  pCurRefTemp = &(ppCurRef[0][RefTM_startX]);
  pCurDecTemp = &(ppCurDec[0][DecTM_startX]);

  stride_ref = ppCurRef[ -TM_size + 1]  - ppCurRef[ -TM_size] - TM_size;
  stride_dec =  ppCurDec[ -TM_size + 1 ] - ppCurDec[ -TM_size ] - TM_size;

  for(i1 = 0; i1 < Blk_height; ++i1)  
  {    
    // get pointers to the X start positions:
//    pCurRefTemp = &(ppCurRef[i1][RefTM_startX]);
//    pCurDecTemp = &(ppCurDec[i1][DecTM_startX]);

    for(j1 = -TM_size; j1 < 0; ++j1)
    {
      temp2 = temp = *pCurRefTemp++;
      temp1 = *pCurDecTemp++;    
#if ( REF_DEC_LUMA_DIF_THRESHOLD < 256)
//      if ( iabs(temp - temp1) <= REF_DEC_LUMA_DIF_THRESHOLD )

      x = (temp - temp1);
      y = x >> INT_BITS;
      z = (x ^ y) - y;
      if ( z <= REF_DEC_LUMA_DIF_THRESHOLD )

/*      x = (temp + 8) >> 4;
      y = (temp1 + 8) >> 4;
      if (x==y)
*/
#endif
      {
#if (0 == USE_SINGLE_MULTIPLIER)
#if(AVERAGED_FACTOR_SH)
        temp = temp >> AVERAGED_FACTOR_SH;	
#endif
#if (USE_TRY_MARK_ALC)
        if( TemplateTryMark !=TemplateTryMarkArray[temp] )
#else
        if (0 == TemplateHistVolume[temp])
#endif
        {
#if (0 == LST_IMPL_OF_ACC)
          // check only if was not checked before?
          if (temp > RefTemplMax)
              RefTemplMax = temp;
          if (temp < RefTemplMin)
              RefTemplMin = temp;
#endif
          //initialization of arrays. In order to exclude memset for the whole array
//          TemplateHistAccRef[temp] = TemplateHistAccDec[temp] = 0;
          // its commented in order to aviod extra if in the correction cycle because otherwise we should chech whether array was initialized or not.
#if (LST_IMPL_OF_ACC)
					// let store pointers for corresponding cells of accumulators 
					pPointer2CellsAccRef[temp] = &TemplateHistAccRef[TemlplateLST_Vol];
					pPointer2CellsAccDec[temp] = &TemplateHistAccDec[TemlplateLST_Vol];
					*(pPointer2CellsAccRef[temp]) = (XPel)temp2;
					*(pPointer2CellsAccDec[temp]) = (XPel)temp1;
					//we also need to save value of reference template pixel in order to calculate weight afterwords
					TemplateHistVl[TemlplateLST_Vol++] = temp;
#endif
#if (USE_TRY_MARK_ALC)
  TemplateTryMarkArray[temp] = TemplateTryMark;
#else
					TemplateHistVolume[temp] = 1;
#endif

        }
#if (0 != LST_IMPL_OF_ACC)
				else
				{
					*(pPointer2CellsAccRef[temp]) +=(XPel)temp2;
					*(pPointer2CellsAccDec[temp]) +=(XPel)temp1;
				}

//        ref_sum += temp2;
//        dec_sum += temp1;
#else
        //filing histogram arrays
        TemplateHistAccRef[temp] += (XPel)temp2;
        TemplateHistAccDec[temp] += (XPel)temp1;
#endif
        ++idx;

#elif (1 == USE_SINGLE_MULTIPLIER || 2 == USE_SINGLE_MULTIPLIER)
        ref_sum += temp2;
        dec_sum += temp1;
#endif
      }
    }

    pCurRefTemp += stride_ref;
    pCurDecTemp += stride_dec;
  }  

  CurTemplateCapacity = CurTemplateCapacityRef = CurTemplateCapacityDec = idx;
	ALC_TurnON();
  TMIsFilled = TM_FILLED;
	return ALCOK;
}

#if(SMRC_3DV && 1 == SMRC_ALC_AFTER_WP)
int ALC_after_WP(	XPel **ppRef, int RefTM_startY, int RefTM_startX, 
				XPel **ppDec, int DecTM_startY, int DecTM_startX, 
				int Blk_height, int Blk_width, int TM_size,
				int FrameH, int FrameW,int max_imgpel_value,
				short wp, short offset, short wp_round, short weight_denom, imgpel** mb_pred, int block_x)
{
  int i1,j1;
  XPel** ppCurRef;
	XPel** ppCurDec;
  int Min_based_on_ref, Max_based_on_ref;
  int *pTemp;
  ppCurRef = &ppRef[ RefTM_startY];
	ppCurDec = &ppDec[ DecTM_startY];
  // fast version
  ALC_GetTM(  ppRef, RefTM_startY, RefTM_startX, 
				      ppDec, DecTM_startY, DecTM_startX, 
				      Blk_height, Blk_width, TM_size,
				      FrameH, FrameW);
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	for(i1 = 0; i1 < Blk_height; i1++)
	{
		for(j1 = 0; j1 < Blk_width; j1++)
		{
			int Ref_Ref = 0;
			int Ref_Dec = 0;
			int Wk = 0;
			int delta,i,rec_vl;
			TMPL_HIST_BIN *ptempHist_bin;
			XPel ReferenceVl = (imgpel) iClip1( max_imgpel_value, ((wp *  *(ppCurRef[i1]+ RefTM_startX + j1)  + wp_round) >> weight_denom) + offset);

		// early termination in case of ReferenceVl was corrected in early stage.
			if(AlreadyProcessed[ReferenceVl] != -1)
			{
				mb_pred[i1][j1 + block_x] = AlreadyProcessed[ReferenceVl];
				continue;
			}

/**************************************************************
code below is taken from 
PiLC_TMPelCorHist_2DArray, PiLC_TMPelCorHist_1DArray
***************************************************************/
#if (0 == USE_SINGLE_MULTIPLIER)
    // Initialization! 1 - in order to avoid division by zero. This is not stricktly correct but quite good approximaation
#if(FIXED_POINT)
      Ref_Ref = (1<<FIXED_POINT_INTER_SHIFT); 
      Ref_Dec = (1<<FIXED_POINT_INTER_SHIFT);
#else
      Ref_Ref = (1); 
      Ref_Dec = (1);
#endif
    //let detect min and max limits based on reference:
#if (AVERAGED_FACTOR_SH)
    Min_based_on_ref = (ReferenceVl - REF_REF_LUMA_DIF_THRESHOLD) >> AVERAGED_FACTOR_SH;
    Max_based_on_ref = (ReferenceVl + REF_REF_LUMA_DIF_THRESHOLD) >> AVERAGED_FACTOR_SH;
#else
    Min_based_on_ref = ReferenceVl - REF_REF_LUMA_DIF_THRESHOLD;
    Max_based_on_ref = ReferenceVl + REF_REF_LUMA_DIF_THRESHOLD;
#endif
    if (Min_based_on_ref < RefTemplMin) Min_based_on_ref = RefTemplMin;
    if (Max_based_on_ref > RefTemplMax) Max_based_on_ref = RefTemplMax;

    //cycle over all the range of histogram:
  #if(!ALC_SPEED_OPT)
	   for(i=0; i < (256 >> AVERAGED_FACTOR_SH); ++i)
  #else
#if (0 == FIXED_UNIT_WEIGHT)
#if (!EXP_TABLE_HALF)
#if (AVERAGED_FACTOR_SH)
    pTemp = pTemplExpTable + ReferenceVl - (Min_based_on_ref<<AVERAGED_FACTOR_SH) - AVERAGED_FACTOR_ROUNDING;
#else    
    pTemp = pTemplExpTable + ReferenceVl - Min_based_on_ref;
#endif
#endif
#endif
	  //for(i = RefTemplMin; i <= RefTemplMax; ++i)
    for(i = Min_based_on_ref; i <= Max_based_on_ref; ++i)    
  #endif
    {
//      if (TemplateHistVolume[i] )
//		  {
  #if(SAVE_REF_MEAN_4_EACH_BIN)
//			int i_rec = (TemplateHist[i].acc_ref + TemplateHist[i].acc_volume/2)/TemplateHist[i].acc_volume;
			int i_rec = (TemplateHistAccRef[i] + (TemplateHistVolume[i]>>1)) / TemplateHistVolume[i];
  #else
    #if (AVERAGED_FACTOR_SH)
			int i_rec = (i << AVERAGED_FACTOR_SH) + AVERAGED_FACTOR_ROUNDING;
    #else
      int i_rec  = i;
    #endif
  #endif
#if ( 0 == FIXED_UNIT_WEIGHT)        

  #if (EXP_TABLE_HALF)
			  delta = abs(ReferenceVl - i_rec);
        Wk = pTemplExpTable[delta];
  #else            
//        delta = (ReferenceVl - i_rec);
//        Wk = pTemplExpTable[delta];
        //more compact
      Wk = *pTemp--;
      
  #endif      
//        if (0 == Wk)
//          continue;
  #if(SAVE_REF_MEAN_4_EACH_BIN)
        Ref_Ref += TemplateHistAccRef[i] * Wk;
  #else
    #if(USE_APPROXIMATED_REF_ACC)
        Ref_Ref += i_rec * Wk * TemplateHistAccRef[i];
    #else
        Ref_Ref += TemplateHistAccRef[i] * Wk;
    #endif
  #endif
        Ref_Dec += TemplateHistAccDec[i] * Wk;
    }
  #if(FIXED_POINT)
    Ref_Dec >>= FIXED_POINT_INTER_SHIFT;
    Ref_Ref >>= FIXED_POINT_INTER_SHIFT;
  #endif
#elif ( 1 == FIXED_UNIT_WEIGHT)
   #if(SAVE_REF_MEAN_4_EACH_BIN)
        Ref_Ref += TemplateHistAccRef[i];
  #else
    #if(USE_APPROXIMATED_REF_ACC)
        Ref_Ref += i_rec * TemplateHistAccRef[i];
    #else
        Ref_Ref += TemplateHistAccRef[i];
    #endif
  #endif
        Ref_Dec += TemplateHistAccDec[i];
    }
#endif
//		  }    
      rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref>>1)) / Ref_Ref);
#elif (1 == USE_SINGLE_MULTIPLIER)
      rec_vl = (int)( (ReferenceVl * mult_factor) >> SINGL_MULT_FACT_PREC);
#elif (2 == USE_SINGLE_MULTIPLIER)
      //this is to avoid additional check of zrro/non-zero value of ref_ref
      rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref>>1)) / Ref_Ref);
#endif
      if (rec_vl > 255) 
          rec_vl = 255;
    #if(ALC_SPEED_OPT)
//	    Template_visit[ReferenceVl] = 1;
      AlreadyProcessed[ReferenceVl] = rec_vl;
    #else
	    rec_vl = (XPel)CLIP(rec_vl, 0, 255);
    #endif

	  //ppOut[k][m] = (XPel)rec_vl; 
      mb_pred[i1][j1 + block_x] = rec_vl;
    }  
  }
	return ALCOK;
}
#endif
#endif



/*
	This Function makes correction of input reference value ReferenceVl based on two types of models:

	Multiplicative mode: Y = X * C	

	in case of additive model, pRefFitlered value returns "filtered" value by means of weights calculated over reference template and 
	based on ReferenceVl

	SigmaN - number of Sigma Table used for smoothing

	Default values:	
	SigmaN = 0


*/
//XPel PiLC_TMPelCorHist(	XPel ReferenceVl, XPel *pRefFitlered, int SigmaN)
XPel PiLC_TMPelCorHistSlow(	XPel ReferenceVl)
{
#if(FIXED_POINT)
	int Ref_Ref = 0;
	int Ref_Dec = 0;
	int Wk = 0;

    int* pTemplExpTable;
#else
	double Ref_Ref = 0;
	double Ref_Dec = 0;
	double Wk = 0;
	//double WGlobal;
    double* pTemplExpTable;
#endif
	int delta;
	int delta_sum;
	int i;
	int rec_vl;
  TMPL_HIST_BIN *ptempHist_bin;

#if(SMRC_ALC_NO_LUMA_COMPENSATION)
	return ReferenceVl;
#endif


// There is no need to check sigma numeber here. Let's suppose SigmaNumber is always correct
// incorrect sigma value, to return input value;
//if ((SigmaN > NUMBER_OF_SIGMA) || (SigmaN < 0))
//if ((SigmaNumber > NUMBER_OF_SIGMA) || (SigmaNumber < 0))
//return ReferenceVl;

#if(ALC_SPEED_OPT)
// early termination in case of ReferenceVl was corrected in early stage.
	if(Template_visit[ReferenceVl] != 0)
	{
		return AlreadyProcessed[ReferenceVl];
	}
#endif

#if(EXP_TABLE_HALF)
    //to get pointer to the appropriate table 
    pTemplExpTable = pExpTableLuma[SigmaN];
#else
    //to get pointer to the appropriate table 
    //pTemplExpTable = pExpTableLuma[SigmaN];
    pTemplExpTable = pExpTableLuma[SigmaNumber];
    pTemplExpTable  = pTemplExpTable + 255;  // to shift 0 position to the 255 position
#endif

	delta_sum = 0;
// TO DO: Do we need to check it here?
	if (! IsTMFilled())
	{
		printf("PiLC_TMPelCorHist: Templates are not filled!'n");
		return (XPel)(255);
	}


	//cycle over all the range of histogram:
#if(!ALC_SPEED_OPT)
	 for(i=0; i < (256 >> AVERAGED_FACTOR_SH); ++i)
#else
	for(i=RefTemplMin; i <= RefTemplMax; ++i)
#endif
	{
#if(SAVE_REF_MEAN_4_EACH_BIN)
			int i_rec = (TemplateHist[i].acc_ref + TemplateHist[i].acc_volume/2)/TemplateHist[i].acc_volume;
#else
  #if (AVERAGED_FACTOR_SH)
			int i_rec = (i << AVERAGED_FACTOR_SH) + AVERAGED_FACTOR_ROUNDING;
  #else
    int i_rec  = i;
  #endif
#endif

      ptempHist_bin = &(TemplateHist[i]);
      if (ptempHist_bin->acc_volume)
      {
#if (EXP_TABLE_HALF)
        delta = abs(ReferenceVl - i_rec);
#else
        delta = (ReferenceVl - i_rec);
#endif
        Wk = pTemplExpTable[delta];
          if (0 == Wk) continue;

#if ( 0 == FIXED_UNIT_WEIGHT)
#if(SAVE_REF_MEAN_4_EACH_BIN)
        Ref_Ref += TemplateHist[i].acc_ref * Wk;
#else
        #if(USE_APPROXIMATED_REF_ACC)
        Ref_Ref += i_rec * Wk * TemplateHist[i].acc_volume;
        #else
        Ref_Ref += ptempHist_bin->acc_ref * Wk;
#endif
#endif
        Ref_Dec += ptempHist_bin->acc * Wk;            
		}
	}

#if(FIXED_POINT)
	Ref_Dec >>= FIXED_POINT_INTER_SHIFT;
	Ref_Ref >>= FIXED_POINT_INTER_SHIFT;
#endif

	if (Ref_Ref)
		rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref/2)) / Ref_Ref);
	else
		rec_vl = (int)ReferenceVl;

#if(ALC_SPEED_OPT)
	Template_visit[ReferenceVl] = rec_vl = (XPel)CLIP(rec_vl, 0, 255);
#else
	rec_vl = (XPel)CLIP(rec_vl, 0, 255);
#endif
	return (XPel)rec_vl;
#elif ( 1 == FIXED_UNIT_WEIGHT)
#if(SAVE_REF_MEAN_4_EACH_BIN)
        Ref_Ref += TemplateHist[i].acc_ref;
#else
    #if(USE_APPROXIMATED_REF_ACC)
  Ref_Ref += i_rec * TemplateHist[i].acc_volume;
    #else
  Ref_Ref += ptempHist_bin->acc_ref;
    #endif
#endif
  Ref_Dec += ptempHist_bin->acc;            
		}
	}


// if FIXED_UNIT_WEIGHT, then no internal increase of bit-depth
#if(FIXED_POINT)
//	Ref_Dec >>= FIXED_POINT_INTER_SHIFT;
//	Ref_Ref >>= FIXED_POINT_INTER_SHIFT;
#endif

	if (Ref_Ref)
		rec_vl = (int)((ReferenceVl * Ref_Dec + (Ref_Ref>>1)) / Ref_Ref);
	else
		rec_vl = (int)ReferenceVl;

#if(ALC_SPEED_OPT)
	//Template_visit[ReferenceVl] = rec_vl = (XPel)CLIP(rec_vl, 0, 255);
  Template_visit[ReferenceVl] = 1;
  AlreadyProcessed[ReferenceVl] = rec_vl = rec_vl > 255 ? 255 : rec_vl;
#else
	rec_vl = (XPel)CLIP(rec_vl, 0, 255);
#endif
	return (XPel)rec_vl;
#endif
}



void PiLC_TMOutput2File()
{
/*
	FILE* flog;
	int i;
	flog = fopen("template_reference.txt", "wb");
	for(i=0; i < CurTemplateCapacity; ++i)
		fprintf(flog, "y = %03d. x = %03d. vl = %03d\n", TemplateRef[i].y, TemplateRef[i].x, TemplateRef[i].vl);
	fflush(flog);
	fclose(flog);

	flog = fopen("template_decoding.txt", "wb");
	for(i=0; i < CurTemplateCapacity; ++i)
		fprintf(flog, "y = %03d. x = %03d. vl = %03d\n", TemplateDec[i].y, TemplateDec[i].x, TemplateDec[i].vl);
	fflush(flog);
	fclose(flog);
*/
}

Boolean IsTMFilled()
{
	if (TM_FILLED == TMIsFilled)
		return TRUE;
	else
		return FALSE;


}


Boolean IsALC_TurnON()
{
	if (ALCTurnONFlag)
		return TRUE;
	else
		return FALSE;
}


Boolean IsALC_TurnON_and_TMFilled()
{
  if (ALCTurnONFlag && TM_FILLED == TMIsFilled)
    return TRUE;
  else
    return FALSE;
}

void ALC_TurnOFF()
{
	ALCTurnONFlag = FALSE;
	TMIsFilled = TM_EMPTY;
}

void ALC_TurnON()
{
	ALCTurnONFlag = TRUE;
}

XPel** ALC_RetTMHorbuf()
{
	return ppTM_horbuf;
};

XPel** ALC_RetTMVerbuf()
{
	return ppTM_verbuf;
}

XPel** ALC_RetTM_buf()
{
	return ppTM_buf;
}

int** ALC_RetTM_tempbuf()
{
	return ppTM_tempbuf;
}

#if( 0 != SMRC_SILENT_ALC_4_PSKIP)
void ALC_save_pred( XPel ** pred)
{
	memcpy( &(pred_buf[0][0]), &(pred[0][0]), sizeof(XPel)*16*16);
}

int getSAD16x16( XPel **p1, int sh1, XPel **p2, int sh2 )
{
  int mcost = 0;
  int y,x;
  short blocksize_x = 16;
  short blocksize_y = 16;
  for (y=0; y<blocksize_y; y++)
    for (x = 0; x < blocksize_x; x++)
      mcost += iabs( p1[y][sh1 + x] - p2[y][sh2 + x]);
	return mcost;
}

static int flag_alc_skip_reviewed = 0;
int ALC_get_best_pred( XPel ** orig, XPel ** pred, int mb_x)
{
	int res = 1;
	int sad_std = getSAD16x16( orig, mb_x, pred_buf, 0 );
	int sad_alc = getSAD16x16( orig, mb_x, pred, 0 );
	//if( sad_alc > sad_std)
	if( (sad_alc+2) > sad_std)
	{
		memcpy( &(pred[0][0]), &(pred_buf[0][0]), sizeof(XPel)*16*16);
		res = 0;
	}

	#if(SMRC_SILENT_ALC_4_PSKIP	== -1)
		if(1 == res_mode_in_skip)
		{
			flag_alc_skip_reviewed = 1;
			fprintf( pfStat, "\t%d", res);
			if(sad_alc == sad_std)
				fprintf( pfStat, "\t1\n");
			else
				fprintf( pfStat, "\t0\n");
		}
	#endif

	return res;
}
#endif

#if( SMRC_SILENT_ALC_4_PSKIP_WITHOUT_SIMILAR_TEMPLATES || SMRC_SILENT_ALC_4_PSKIP_WITHOUT_DISSIMILAR_TEMPLATES)
int ALC_set_skip_mode( int mode, int is_interview)
{
	enabled_alc_skip = mode;
	pred_direction_is_interview = is_interview;
	return 0;
}

int ALC_get_skip_mode()
{
	return res_mode_in_skip;
}

int ALC_check_similarity()
{
	int i,j;
	int sad = 0;

#if SMRC_SILENT_ALC_4_PSKIP_CONSTRAINTS_4IV_ONLY
	if(0 == pred_direction_is_interview)
		return ALCOK;
#endif

	for( i = 0; i < CurTemplateCapacity; i+=16)
	{
		int dcR = 0;
		int dcD = 0;
		for( j = i; j < i+16; j++)
		{
			dcR += TemplateRef[j];
			dcD += TemplateDec[j];
		}
		sad += iabs(dcR/16 - dcD/16);
	}

	#if(SMRC_SILENT_ALC_4_PSKIP		== -1)
		fprintf( pfStat, "\t%d", sad);
		return ALCOK;
	#endif

	if(sad < SIMILAR_THRESHOLD)
		return ALCERR_NOTVALID_TMPL_4SKIP;
	else
		return ALCOK;
}

//mr
int ALC_check_dissimilarity()
{
	int i,j;
	int sad = 0;

#if SMRC_SILENT_ALC_4_PSKIP_CONSTRAINTS_4IV_ONLY
	if(0 == pred_direction_is_interview)
		return ALCOK;
#endif

	for( i = 0; i < CurTemplateCapacity; i+=16)
	{
		int diff;
		int dcR = 0;
		int dcD = 0;
		for( j = i; j < i+16; j++)
		{
			dcR += TemplateRef[j];
			dcD += TemplateDec[j];
		}
		diff = ((dcR + 8) >> 4) - ((dcD + 8) >> 4);
		for( j = i; j < i+16; j++)
			sad += iabs(TemplateRef[j] - TemplateDec[j] - diff);
	}

	#if(SMRC_SILENT_ALC_4_PSKIP		== -1)
		fprintf( pfStat, "\t%d", sad);
		return ALCOK;
	#endif

	if(sad > DISSIMILAR_MR_THRESHOLD*CurTemplateCapacity)
		return ALCERR_NOTVALID_TMPL_4SKIP;
	else
		return ALCOK;
}

/*
//dc
int ALC_check_dissimilarity()
{
	int i,j;
	int sad = 0;

#if SMRC_SILENT_ALC_4_PSKIP_CONSTRAINTS_4IV_ONLY
	if(0 == pred_direction_is_interview)
		return ALCOK;
#endif

	for( i = 0; i < CurTemplateCapacity; i+=16)
	{
		int dcR = 0;
		int dcD = 0;
		for( j = i; j < i+16; j++)
		{
			dcR += TemplateRef[j].vl;
			dcD += TemplateDec[j].vl;
		}
		sad += iabs(dcR/16 - dcD/16);
	}

	#if(SMRC_SILENT_ALC_4_PSKIP		== -1)
		fprintf( pfStat, "\t%d", sad);
		return ALCOK;
	#endif

	if(sad > DISSIMILAR_DC_THRESHOLD)
		return ALCERR_NOTVALID_TMPL_4SKIP;
	else
		return ALCOK;
}
*/

/*
int ALC_check_dissimilarity()
{
	int i,j;
	int sad = 0;

#if SMRC_SILENT_ALC_4_PSKIP_CONSTRAINTS_4IV_ONLY
	if(0 == pred_direction_is_interview)
		return ALCOK;
#endif

	for( i = 0; i < CurTemplateCapacity; i++)
	{
		if(iabs((int)TemplateRef[i].vl - (int)TemplateDec[i].vl) > 20)
			++sad;
	}

	#if(SMRC_SILENT_ALC_4_PSKIP		== -1)
		fprintf( pfStat, "\t%d", sad);
		return ALCOK;
	#endif

	if(sad > CurTemplateCapacity/2)
		return ALCERR_NOTVALID_TMPL_4SKIP;
	else
		return ALCOK;
}
*/
/*
int ALC_check_dissimilarity()
{
	int i,j;
	int sad = 0;

#if SMRC_SILENT_ALC_4_PSKIP_CONSTRAINTS_4IV_ONLY
	if(0 == pred_direction_is_interview)
		return ALCOK;
#endif

	for( i = 0; i < ref_blk_size; i++)
	{
		int res;
		int val = ref_blk[i];
	//	if(val <= RefTemplMin)
	//		res = iabs(RefTemplMin-ref_blk[i]);
	//	else if(val >= RefTemplMax)
	//		res = iabs(RefTemplMax-ref_blk[i]);
	//	else
	//	{
	//		int to_min = 0;
	//		int to_max = 0;
	//		val = ref_blk[i];
	//		while(val >= RefTemplMin)
	//		{
	//			if(TemplateHist[val].acc_volume)
	//				break;
	//			--val;
	//		}
	//		to_min = iabs(val-ref_blk[i]);

	//		val = ref_blk[i];
	//		while(val <= RefTemplMax)
	//		{
	//			if(TemplateHist[val].acc_volume)
	//				break;
	//			++val;
	//		}
	//		to_max = iabs(val-ref_blk[i]);
	//		if(to_min < to_max)
	//			res = to_min;
	//		else
	//			res = to_max;
	//	}

		if(TemplateHist[val].acc_volume == 0)
			++sad;
		//sad += res;
	}

	#if(SMRC_SILENT_ALC_4_PSKIP		== -1)
		fprintf( pfStat, "\t%d", sad);
		return ALCOK;
	#endif

	if(sad > CurTemplateCapacity/2)
		return ALCERR_NOTVALID_TMPL_4SKIP;
	else
		return ALCOK;
}*/

#if(SMRC_SILENT_ALC_4_PSKIP		== -1)
void ALC_real_skip(int skip_decision)
{
	if(flag_alc_skip_reviewed == 1)
	{
		fprintf( pfStat, "0\t%d\t%d\t%d\t%d\n", skip_decision, skip_decision, skip_decision, skip_decision);
		flag_alc_skip_reviewed = 0;
	}
}
#endif

#endif

#if(SMRC_ALC_SENSITIVE_LOOPBACK)
int ALC_get_strength( int cur_mb_alc_flag, int neib_mb_alc_flag, int cur_strength, int edge)
{
	int type = cur_mb_alc_flag + neib_mb_alc_flag;
	int res_str = cur_strength;
	if(0 == edge)
	{
		if( 1 == type )
		{// boundary between ALC and non-ALC macroblocks
			res_str = 2;
		}
		else if(2 == type)
		{// boundary between two ALC macroblocks
			if(cur_strength < 2)
				res_str += 1;
		}
	}
	else if(1 == cur_mb_alc_flag)
	{// inside ALC macroblock
		if(cur_strength < 2)
			res_str += 1;
	}
	return res_str;
}
#endif

#if(ALC_FLAG_IN_SLICE_HEADER)
int ALC_FrameAdaptability( char* fnc, char* fns, imgpel** curpic, imgpel** synpic, int height, int width, int qp)
{
	int	i,j,k,m;
	unsigned int curhyst[256];
	unsigned int sinhyst[256];
	unsigned int hsad = 0;
	unsigned int allblocks = 0;
	int bs = 32;
	int thresh = 32;
	double threshQP = 1.0*qp/30 - 0.5;
	/*FILE* fhc = fopen( fnc, "wt");
	FILE* fhs = fopen( fns, "wt");

	memset( curhyst, 0, 256*sizeof(unsigned int));
	memset( sinhyst, 0, 256*sizeof(unsigned int));

	for( i = 0; i < height; i++)
	{
		for( j = 0; j < width; j++)
		{
			if(abs(curpic[i][j] - synpic[i][j]) < thresh)
			{
			++curhyst[curpic[i][j]];
			++sinhyst[synpic[i][j]];
		}
	}
	}

	for( i = 0; i < 256; i++)
	{
		fprintf( fhc, "%d\n", curhyst[i]);
		fprintf( fhs, "%d\n", sinhyst[i]);
	}
	fclose( fhc);
	fclose( fhs);
	*/

	
	//FILE* fh = fopen( fnc, "wt");
	for( i = 0; i <= height-bs; i+=bs)
	{
		for( j = 0; j <= width-bs; j+=bs)
		{
			int sumc = 0;
			int sums = 0;
			int sumtc = 0;
			int sumts = 0;
			int cnt = 0;
			for( k = i; k < i+bs; k++)
			{
				for( m = j; m < j+bs; m++)
				{
					sumc += curpic[k][m];
					sums += synpic[k][m];
					if(abs(curpic[k][m] - synpic[k][m]) < thresh)
					{
						sumtc += curpic[k][m];
						sumts += synpic[k][m];
						cnt++;
					}
				}
			}
			//fprintf( fh, "%d %d %d %d %d\n", sumc, sums, sumtc, sumts, cnt);
			++allblocks;
			//if( 2*abs(sumtc - sumts) > (cnt+1))
			if( abs(sumtc - sumts) > threshQP*cnt)
				++hsad;
		}
	}
	//fclose( fh);

/*
	for( i = 0; i < 256; i++)
	{
		curhyst[i] = curhyst[i]/(height*width/10000);
		sinhyst[i] = sinhyst[i]/(height*width/10000);
	}

	for( i = 0; i < 256; i++)
	{
		hsad+= abs(curhyst[i]-sinhyst[i]);
	}
	*/
	if(hsad > allblocks*0.35)
	{
		printf(" ALC Enb ");
		return 1;
	}
	else
	{
		printf(" ALC Dis ");
		return 0;
	}
}
#endif//ALC_FLAG_IN_SLICE_HEADER


