#ifndef STRICT
#define STRICT
#endif // STRICT

#ifndef WIN32_LEAN_AND_MEAN
#define WIN32_LEAN_AND_MEAN
#endif // WIN32_LEAN_AND_MEAN

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifdef _WIN32
#include <tchar.h>
#include <crtdbg.h>
#endif // _WIN32

#include "ALC_Logic.h"


	//debug data
	static XPel* pALCFrame = NULL;
	static int ALCFrameH;
	static int ALCFrameW;
	static Boolean IsMemAllocated = FALSE;

/*
	Like a constructor:
*/
void ALC_Create(int FrameH, int FrameW)
{   
	PiLC_Create();

	//init template storage
	PiLC_TMInit();

	
	if (!IsMemAllocated)
	{
		ALCFrameH = FrameH;
		ALCFrameW = FrameW;
		pALCFrame = malloc(ALCFrameH * ALCFrameW * sizeof(XPel));
		IsMemAllocated = TRUE;
	}
	else
	{
		if ( ALCFrameH != FrameH || ALCFrameW != FrameW )
		{
			free(pALCFrame);
			ALCFrameH = FrameH;
			ALCFrameW = FrameW;
			pALCFrame = malloc(ALCFrameH * ALCFrameW * sizeof(XPel));

		}

	}
}
void ALC_CreateSimple()
{   
	PiLC_Create();

	//init template storage
	PiLC_TMInit();	
}
/*
	Like a desructor:
*/
void ALC_Destroy()
{
	PiLC_Destroy();

	if (IsMemAllocated)
		free(pALCFrame);
}

void ALC_set_tmpl_types( int* pPartitions, int num)
{
	// 0 - global templite
	// 1 - local 4x4 templite
	memset( pPartitions, 0, sizeof(int)*num);
	pPartitions[0] = 0;			// skip
	if( num >= 15)
		pPartitions[15] = 0;		// MERL skip
	pPartitions[1] = 0;			// 16x16
	pPartitions[2] = 1;			// 16x8
	pPartitions[3] = 1;			// 8x16
	pPartitions[4] = pPartitions[8] = 1;			// 8x8

	// don't change because template inside subpartitioning always local
	pPartitions[5] = 1;			// 8x4
	pPartitions[6] = 1;			// 4x8
	pPartitions[7] = 1;			// 4x4

}

void ALC_ClearALCFrame()
{
//	memset(pALCFrame, 0, sizeof(XPel) * ALCFrameH * ALCFrameW); 
}
void ALC_WritePelBlock(XPel* pSrc, int SrcY, int SrcX, int SrcStride, int DstY, int DstX, int BlkH, int BlkW)
{
  /*
	int i;
	int j;
	if (IsMemAllocated)
	{
		for(i = 0; i < BlkH; ++i)
			for(j = 0; j < BlkW; ++j)
			{
				pALCFrame[(DstY + i) * ALCFrameW + (DstX + j)] = pSrc[(SrcY + i) * SrcStride + (SrcX + j)];
			}
	}
  */
}

void ALC_WriteALCFrame2File()
{
	/*
	FILE* file;
	int  i;
	XPel ch;
	if (IsMemAllocated)
	{
		file = fopen("ALCFrame400.yuv", "wb");
		ch = 128;
		

		fwrite(pALCFrame, sizeof(XPel), ALCFrameW * ALCFrameH, file);
		for(i = 0; i < (ALCFrameW * ALCFrameH / 2); ++i)
			fwrite(&ch, sizeof(XPel), 1, file);
		fclose(file);
	}
	*/
}