/*!
 ************************************************************************
 * \file hmst_processing.h
 *
 * \brief
 *    headers for hmst tool common functions
 *
 * \author
 *    Main contributors
 *     - Michael Mishourovsky   <mike.mishky@samsung.com>
 *     - Alexis Fartukov        <a.fartukov@samsung.com> 
 *     - Igor Kovliga           <i.kovliga@samsung.com> 
 *     - Konstantin Dubkov      <k.dubkov@samsung.com> 
 *  
 ************************************************************************
 */
#ifndef _DEBUG_COMMON_FUNCS_H_
#define _DEBUG_COMMON_FUNCS_H_

#include "global.h"
#include "typedefs.h"

#if(DEBUG_PROCESSING)

  extern int save_pict_imgpel(const char* filename, imgpel **pRImage, imgpel **pGImage, imgpel **pBImage, int height, int width);
  //extern int save_pict_hf_hifpel(const char* filename, hifpel **pImage, int height, int width);


  extern void GetPSNRwith2mask( imgpel** pPelOrig, imgpel** pPelRec, imgpel** pMaskMap1, imgpel** pMaskMap2, imgpel sig1, imgpel sig2, int h, int w, double* psnr, int* ProcessedNumber);
  extern void GetMR4x4PSNRwith2mask( imgpel** pPelOrig, imgpel** pPelRec, imgpel** pMaskMap1, imgpel** pMaskMap2, imgpel sig1, imgpel sig2, int h, int w, double* psnr, int* ProcessedNumber);

  extern void GetBlockFromPelArray( imgpel** pFrame, int y_frm, int x_frm, imgpel** pBlock, int blk_h, int blk_w);
  // calculate SAD between templates without DC (return DC difference in "delta")
  extern int Template1LSADnDC( imgpel** pS1, imgpel** pS2, int subblk_h , int subblk_w, int tmpl_w, int* deltares);
  // add specified number to each pixel inside the block
  extern void AddNum( imgpel** pS1, int chisla, imgpel** pS2, int h , int w);

	extern void db_set_pred(Macroblock *currMB, short    mode);
	extern void db_set_final_mb(Macroblock *currMB);
#endif

#endif//_DEBUG_COMMON_FUNCS_H_
