#ifndef _DEFS_ALC_COMMON_
#define _DEFS_ALC_COMMON_

//#define SMRC_3DV_GOTO_REF_ATM	    // this is very debug stuff. If we want to roll-out all our modifications in the encoder and get baseline REFERENCE ATM, just define this define. 

    #define ALC_FLAG_IN_SPS           1   // enables writing AdaptiveLuminanceCompensation flag into SPS
    #define ALC_FLAG_IN_SLICE_HEADER  0   // enables writing alc_slice_flag flag into slice header

	#define DISABLE_TRANSFORM_8x8     0   // !< disables using transform 8x8 in ALC mode

	#define SMRC_ALC_REAL_REF_IDX     1 
	#define SEPARATE_ALC_MVP					0 
	#define SMRC_ATTRACT2ZERO					0 // if 1 and SEPARATE_ALC_MVP==0, then all of MVs for non-ALC blocks are set to zero (in case of MV prediction calculation for ALC mode)

	#define ALC_QPC                   0 //increase of quantization parameter for chroma components of ALC blocks

	#define SMRC_ALC_16x16_SOLID			1	// 1 - block is processed by using global template for all macroblock (in case of P16x16 mode)
												// 0 - block is processed by using local  template for each of 4x4 blocks (in case of P16x16 mode)

	#define SMRC_SILENT_ALC_4_PSKIP		-2 // force ALC mode in Skip mode (by using global template): SMRC_SILENT_ALC_4_PSKIP == 1.
																			//-2 - Explicit flag for ALC in Skip mode
																			//-1 - Selection of best case of Skip mode (ALC or non-ALC)
																			// 0 - ALC is turned off in Skip mode
																			// 1 - Both Skip modes are used
																			// 2 - ALC is used in standard Skip mode only
																			// 3 - ALC is used in MERL Skip mode
	#define SMRC_SILENT_ALC_4_PSKIP_PLUS_INTERVIEW		1
	#define SMRC_EXPLICIT_ALC_4_PSKIP_CHANGERULES_1		1
	#define SMRC_PREVENT_ALC_INSKIP_WHEN_ALC_CTX_IS_0		0

	#define SMRC_PMERL_FROM_INTERVIEW									0	// 0 - MERL from VSP
																											// 1 - MERL from interview
																											// 2 - usual MERL from VSP and alc MERL from interview

	#define SMRC_CHECK_ALC_SKIP_BEFORE_STANDARD_MODES	1

	#if(SMRC_SILENT_ALC_4_PSKIP != 0)
		#define ALC_IN_SKIP_ONLY 0
	#else
		#define ALC_IN_SKIP_ONLY 0
	#endif

	#define DISABLE_SMB_IN_ALC				0    // this define disable SMB for ALC macroblocks ( if it is set to 1): disabled SMB: 8x4, 4x8, 4x4. 

	#define SMRC_ALC_NO_LUMA_COMPENSATION				0 // 1 - luminance compensation is turned off

	#define SMRC_ALC_ADAPT_TMPL_BY_TRASFLAG 1 // 1 - template adaptation by transform flag is used in case of 16x16 partitioning
											  // if 8x8 transform is used then ALC use global template, if 4x4 - use local template 
                                              // (except of 16x16 partitioning where locality of template is bounded by 8x8 block)

	#define SMRC_ALC_FULL_TMPL				0 // 1 - left upper block is added to template

	#define SMRC_ALC_SENSITIVE_LOOPBACK		0 // 1 - take into consideration of ALC blocks in loopback filter (only for external boundaries of ALC blocks)

	#define SMRC_EXPLICIT_FLAG				0 // 1 - enable reading/writing of additional file which is contained additional information for decoding (need for proof of concept)

	#define SMRC_DMVP_IN_ALC_DISABLE			0

	#define ALC_INTERVIEW_ENABLE					1
    #define ALC_INTERVIEW_ONLY_REF                  1           // in case ALC_INTERVIEW_ENABLE = 1 for ALC, this define determines whether only IV reference or IV + VSP are used.
  

    #if (ALC_INTERVIEW_ENABLE)
        #if (ALC_INTERVIEW_ONLY_REF)
            #define ALC_INTERVIEW_REF_IDX				0
    				#define ALC_INTERVIEW_FLAG						0
        #else
    	    #define ALC_INTERVIEW_REF_IDX				1//1
    	    #define ALC_INTERVIEW_FLAG					0
        #endif
    #endif // (ALC_INTERVIEW_ENABLE)

	#define ALC_MULTIPLE_CONTEXT      0 // 1 - separate contexts of ALC mode flag
	#if (ALC_MULTIPLE_CONTEXT)
	#define NUM_SMRC_3DV_MODES_CTX 4
	#endif // (ALC_MULTIPLE_CONTEXT)
	#define NUM_MB_SMRC_3DV_CTX 3

	#define SMRC_ALC_BFRAMES_ENABLED									0 //1
	#define SMRC_ALC_BMERL_ALC_ONLY										0
	#define SMRC_EXPLICIT_ALC_4_BSKIP_CHANGERULES_1		0 //1
	#define SMRC_EXPLICIT_ALC_4_BSKIP_CHANGERULES_1_CONDITIONAL	0 //1
	
	#define SMRC_ALC_AFTER_WP				2		// 0 -     ( WP)
																			// 1 -     ( WP)
																			// 2 -    WP  .

	#define SMRC_ALC_NO_IN_MERL			1

	#define SMRC_ALC_INTMV_REFTEMPLATE			0 //            (      )

#endif//_DEFS_ALC_COMMON_
